package db

import (
	"applet/app/db/model"
	"applet/app/md"
	"applet/app/utils"
	"applet/app/utils/logx"
	"errors"
	"github.com/syyongx/php2go"
	"strings"
	"time"
	"xorm.io/xorm"
)

func SecondFreeProductList(Db *xorm.Engine, args *md.NewProductArgs) []*model.SecondNewcomersFreeProduct {
	query := "`is_del` = 0 and is_show = 1 and stock>0"
	if args.PriceType != "" {
		query += " and price_type = " + args.PriceType
	}
	if args.Title != "" {
		query += " and title LIKE '%" + args.Title + "%'"
	}
	nowStr := time.Now().Format("2006-01-02 15:04:05")
	query += " and start_time<'" + nowStr + "'"
	query += " and end_time>'" + nowStr + "'"
	if args.ProductId != "" {
		query += " and id = " + args.ProductId
	}
	//if args.Page == 0 {
	//	args.Page = 1
	//}
	//size := 10
	//start := size * (args.Page - 1)
	var productList []*model.SecondNewcomersFreeProduct
	if err := Db.Where(query).Limit(args.Size, (args.P-1)*args.Size).Desc("id").Find(&productList); err != nil {
		_ = logx.Warn(err)
	}
	return productList
}
func SecondOneProduct(Db *xorm.Engine, productId string) *model.SecondNewcomersFreeProduct {
	query := "`is_del` = 0 and is_show = 1"
	query += " and id = " + productId
	var product model.SecondNewcomersFreeProduct
	if _, err := Db.Where(query).Get(&product); err != nil {
		_ = logx.Warn(err)
	}
	return &product
}

func SecondGetAllPriceType(Db *xorm.Engine) (map[int]string, error) {
	var priceType []model.SecondNewcomersFreePriceType
	if err := Db.Find(&priceType); err != nil {
		return nil, logx.Warn(err)
	}
	r := make(map[int]string, len(priceType))
	for _, v := range priceType {
		r[v.Id] = v.PriceName
	}
	return r, nil
}
func SecondGetAllPriceTypeList(Db *xorm.Engine) ([]model.SecondNewcomersFreePriceType, error) {
	var priceType []model.SecondNewcomersFreePriceType
	if err := Db.Find(&priceType); err != nil {
		return nil, logx.Warn(err)
	}
	return priceType, nil
}

func SecondGetPriceTypeById(Db *xorm.Engine, id int) *model.SecondNewcomersFreePriceType {
	var price model.SecondNewcomersFreePriceType
	if _, err := Db.Where("`is_del` = 0 and `is_show` = 1 and id=?", id).Get(&price); err != nil {
		_ = logx.Warn(err)
	}
	return &price
}
func SecondFreeProductByID(Db *xorm.Engine, gid, skuId, provider string) (*model.SecondNewcomersFreeProduct, error) {
	m := new(model.SecondNewcomersFreeProduct)
	var has bool
	var err error
	if utils.InArr(provider, []string{md.PVD_TB, md.PVD_TM}) && php2go.IsNumeric(gid) == false {
		gidArr := strings.Split(gid, "-")
		if len(gidArr) == 2 {
			gid = gidArr[1]
		}
		has, err = Db.Where("good_id LIKE ?", "%-"+gid).Get(m)
	} else {
		sess := Db.Where("good_id=?", gid)
		if skuId != "" {
			sess.Or("good_id=?", skuId)
		}
		has, err = sess.Get(m)
	}

	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("Not Found")
	}
	return m, nil
}
func SecondFreePriceTypeByID(Db *xorm.Engine, id interface{}) (*model.SecondNewcomersFreePriceType, error) {
	m := new(model.SecondNewcomersFreePriceType)
	has, err := Db.ID(id).Get(m)
	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("Not Found")
	}
	return m, nil

}
