package db

import (
	"applet/app/db/model"
	"applet/app/utils"
	"time"
	"xorm.io/xorm"
)

func GetUserAlipayInfo(eg *xorm.Engine, uid int) *model.UserAlipayInfo {
	var data model.UserAlipayInfo
	get, _ := eg.Where("uid=?", uid).Get(&data)
	if get == false {
		data = model.UserAlipayInfo{
			Uid:     uid,
			RunTime: int(time.Now().Unix()),
			IsOpen:  1,
		}
		eg.Insert(&data)
	}
	currentMonth := utils.GetTimeRange("current_month")
	if data.RunTime < int(currentMonth["start"]) {
		data.Money = "0"
		data.RunTime = int(time.Now().Unix())
		eg.Where("id=?", data.Id).Cols("money,run_time").Update(data)
	}
	return &data
}
func GetUserAlipayInfoByAlipay(eg *xorm.Engine, alipayId string) *model.UserAlipayInfo {
	var data model.UserAlipayInfo
	get, _ := eg.Where("alipay_id=?", alipayId).Get(&data)
	if get == false {
		return nil
	}
	return &data
}
func GetUserAlipayInfoByOutAgreementNo(eg *xorm.Engine, outAgreementNo string) *model.UserAlipayInfo {
	var data model.UserAlipayInfo
	get, _ := eg.Where("sign_create_id=?", outAgreementNo).Get(&data)
	if get == false {
		return nil
	}
	return &data
}
func GetUserAlipayInfoByCreditAgreementId(eg *xorm.Engine, creditAgreementId string) *model.UserAlipayInfo {
	var data model.UserAlipayInfo
	get, _ := eg.Where("credit_agreement_id=?", creditAgreementId).Get(&data)
	if get == false {
		return nil
	}
	return &data
}
