package db

import (
	"errors"
	"xorm.io/xorm"

	"applet/app/db/model"
	"applet/app/utils/logx"
)

// 批量获取订单信息1
func DbsOrderFindByIds(eg *xorm.Engine, pvd string, ids []string) (*[]model.OrdList, error) {
	var ord []model.OrdList
	if err := eg.In("pvd_oid", ids).
		Where("pvd = ?", pvd).
		Desc("ord_id").
		Find(&ord); err != nil {
		return nil, logx.Error(err)
	}
	if len(ord) == 0 {
		return nil, nil
	}
	return &ord, nil
}
func DbsOrderFindByIdsNew(eg *xorm.Engine, pvd string, ids []string) (*[]model.OrdList, error) {
	var ord []model.OrdList
	if err := eg.In("pvd_oid", ids).
		Where("pvd = ?", pvd).
		Find(&ord); err != nil {
		return nil, logx.Error(err)
	}
	if len(ord) == 0 {
		return nil, nil
	}
	return &ord, nil
}
func DbsOrderFindById(eg *xorm.Engine, pvd string, ids string) (*model.OrdList, error) {
	var ord model.OrdList
	if has, err := eg.In("pvd_oid", ids).
		Where("pvd = ? and pvd_oid=?", pvd, ids).
		Desc("ord_id").
		Get(&ord); err != nil || has == false {
		if err == nil {
			err = errors.New("无数据")
		}
		return nil, logx.Error(err)
	}
	return &ord, nil
}

func DbsOrderUpdate(eg *xorm.Engine, id int64, ord *model.OrdList) error {
	if _, err := eg.Where("`ord_id` = ?", id).Cols("wait_settle_at,parent_ord_id,reason,order_compare,state,paid_price,confirm_at,check_success_at,update_at,pvd_settle_at").Update(ord); err != nil {
		return logx.Warn(err)
	}
	return nil
}
func DbsOrderUpdateWithCols(eg *xorm.Engine, id int64, ord *model.OrdList, cols string) error {
	if _, err := eg.Where("`ord_id` = ?", id).Cols(cols).Update(ord); err != nil {
		return logx.Warn(err)
	}
	return nil
}
func DbsOrderInsert(eg *xorm.Engine, ord *model.OrdList) bool {
	_, err := eg.InsertOne(ord)
	if err != nil {
		logx.Warn(err)
		return false
	}
	return true
}
