package model

type AcquisitionRewardLog struct {
	Id         int    `json:"id" xorm:"not null pk autoincr INT(10)"`
	Uid        int    `json:"uid" xorm:"not null default 0 INT(11)"`
	CoinId     int    `json:"coin_id" xorm:"not null default 0 INT(11)"`
	RewardType int    `json:"reward_type" xorm:"not null default 0 INT(11)"`
	ToUid      int    `json:"to_uid" xorm:"not null default 0 comment('被邀请人uid') INT(11)"`
	Title      string `json:"title" xorm:"not null comment('标题') VARCHAR(255)"`
	Source     int    `json:"source" xorm:"not null default 0 comment('1为直推奖励
2为间推奖励
3为额外奖励
4为榜单奖励
来源标识') TINYINT(4)"`
	SourceText string `json:"source_text" xorm:"not null default '' comment('来源text') VARCHAR(255)"`
	JobsTag    int    `json:"jobs_tag" xorm:"comment('任务标识，只有额外奖励有') TINYINT(1)"`
	Money      string `json:"money" xorm:"not null default 0.00 comment('奖励金额') DECIMAL(10,2)"`
	CreatedAt  int    `json:"created_at" xorm:"not null comment('创建时间') INT(10)"`
	GivenAt    int    `json:"given_at" xorm:"comment('奖励发放时间') INT(10)"`
	State      int    `json:"state" xorm:"not null default 1 comment('发放状态 0未发放 1已发放') TINYINT(1)"`
	IsFrozen   int    `json:"is_frozen" xorm:"not null default 0 comment('冻结状态 0未冻结 1已冻结') TINYINT(1)"`
	UpdatedAt  int    `json:"updated_at" xorm:"comment('更新时间') INT(10)"`
}
