package taobao

import (
	"encoding/json"
	"fmt"
	"time"

	"applet/app/utils"
	"applet/app/utils/logx"
)

type PunishRefundOrder struct {
	PunishStatus  string `json:"punish_status"`
	ViolationType string `json:"violation_type"`
	TbTradeID     int64  `json:"tb_trade_id"`
}

// 淘宝处罚订单
func (t *TB) PunishRefundOrder(pageNo, pageSize int, sTime, day int64) (*[]PunishRefundOrder, error) {
	st := time.Unix(sTime, 0).Format("2006-01-02 15:04:05")
	method := "taobao.tbk.sc.punish.order.get"
	searchOption := map[string]string{
		"page_no":    utils.IntToStr(pageNo),
		"page_size":  utils.IntToStr(pageSize),
		"span":       utils.Int64ToStr(day), //	查询时间跨度，不超过30天，单位是天
		"start_time": st,                    // 2019-04-05 12:18:22
	}
	params := map[string]string{
		"session":         t.SID,
		"af_order_option": string(utils.Serialize(searchOption)),
	}
	resp, err := send(params, method, t.Svc_AK, t.Svc_SK)
	fmt.Println(params)
	fmt.Println(string(resp))
	if err != nil {
		return nil, logx.Warn(err)
	}

	tmp := struct {
		TbkScPunishOrderGetResponse struct {
			Result struct {
				Data struct {
					PageNo   int64 `json:"page_no"`
					PageSize int64 `json:"page_size"`
					Results  struct {
						Result []PunishRefundOrder `json:"result"`
					} `json:"results"`
					TotalCount int64 `json:"total_count"`
				} `json:"data"`
			} `json:"result"`
		} `json:"tbk_sc_punish_order_get_response"`
	}{}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn(resp)
	}
	if len(tmp.TbkScPunishOrderGetResponse.Result.Data.Results.Result) == 0 {
		return &[]PunishRefundOrder{}, nil
	}
	var orderInfo = tmp.TbkScPunishOrderGetResponse.Result.Data.Results.Result
	return &orderInfo, err
}
