package zhimeng

import (
	"applet/app/md"
	"applet/app/utils"
	"applet/app/utils/logx"
	"encoding/json"
)

func CarChargingConvertUrl(appkey, appsecret string, lat float64, lng float64, user *md.User) (*md.OfficialRecommendUrl, error) {

	args := map[string]interface{}{
		"appkey":     appkey,
		"secret_key": appsecret,
		"phone":      user.Info.Phone,
		"lat":        utils.Float64ToStrByPrec(lat, 6),
		"lng":        utils.Float64ToStrByPrec(lng, 6),
	}
	resp, err := Send("fleetingpower", "list_url_new", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			Url string `json:"url"` //
			Seq string `json:"seq"` //
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}
	return &md.OfficialRecommendUrl{
		Url: tmp.Data.Url,
		Seq: tmp.Data.Seq,
	}, nil
}
