package zhimeng

import (
	"applet/app/e"
	"applet/app/md"
	"applet/app/utils"
	"applet/app/utils/logx"
	"encoding/json"
)

func CreditCardOrderTrack(appKey, appSecret string, sTime, eTime int64) (*[]md.OrderInfo, error) {
	params := map[string]interface{}{
		"appkey":     appKey,
		"secret_key": appSecret,
		"start_time": utils.Int64ToStr(sTime), // 时间戳
		"end_time":   utils.Int64ToStr(eTime), // 时间戳
		"is_zyos":    "1",
	}
	resp, err := Send("creditcard", "get_zyos_order", params)
	if err != nil {
		return nil, logx.Warn(err)
	}
	//ioutil.WriteFile("1.json",resp,0777)
	type AutoGenerated struct {
		BankName       string `json:"bankName"`
		CardName       string `json:"cardName"`
		CustName       string `json:"custName"`
		MobileNo       string `json:"mobileNo"`
		ApplyStatus    string `json:"applyStatus"`
		IssueFlag      string `json:"issueFlag"`
		FailReason     string `json:"failReason"`
		UserID         string `json:"user_id"`
		OrgBonus       string `json:"orgBonus"`
		Oid            string `json:"oid"`
		CreateDatetime string `json:"createDatetime"`
		CompletionFlag string `json:"completionFlag"`
		RemittanceFlag string `json:"remittanceFlag"`
	}
	var tmp struct {
		Success int    `json:"success"`
		Msg     string `json:"msg"`
		Data    []struct {
			BankName       string `json:"bankName"`
			CardName       string `json:"cardName"`
			CustName       string `json:"custName"`
			MobileNo       string `json:"mobileNo"`
			ApplyStatus    string `json:"applyStatus"`
			IssueFlag      string `json:"issueFlag"`
			FailReason     string `json:"failReason"`
			UserID         string `json:"user_id"`
			OrgBonus       string `json:"orgBonus"`
			Oid            string `json:"oid"`
			CreateDatetime string `json:"createDatetime"`
			CompletionFlag string `json:"completionFlag"`
			RemittanceFlag string `json:"remittanceFlag"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: + " + string(resp) + " + err:" + err.Error())
	}
	if len(tmp.Data) == 0 {
		return nil, e.NewErrCode(e.ERR_NO_DATA)
	}
	if len(tmp.Data) == 0 {
		return nil, nil
	}

	//var (
	//	res       []md.OrderInfo
	//	state     int
	//	reason    string
	//	orderType int
	//)
	//for _, v := range tmp.Data {
	//
	//	state = kfcState[v.Status]
	//	if state == md.OrderStateFail {
	//		reason = v.Status
	//	}
	//	res = append(res, md.OrderInfo{
	//		PvdOid:     v.Oid,
	//		Pid:        "self_" + v.UID,
	//		Pvd:        md.PVD_KFC,
	//		ItemNum:    1,
	//		ItemPrice:  utils.AnyToFloat64(v.Payment),
	//		ItemTitle:  v.Info,
	//		PaidPrice:  utils.AnyToFloat64(v.Payment),
	//		OrderType:  orderType, // 默认为自购
	//		State:      state,
	//		Commission: utils.StrToFloat64(v.Commission),
	//		Reason:     reason,
	//		PayTime:    utils.StrToInt64(v.CreateTime),
	//		StartTime:  utils.StrToInt64(v.CreateTime),
	//		EndTime:    utils.StrToInt64(v.ZmUpdateTime),
	//	})
	//}
	return nil, nil
}
