package zhimeng

import (
	"encoding/json"
	"fmt"

	"applet/app/md"
	"applet/app/utils/logx"
)

// promoId一般使用自购ID拼装起来
func JDConvertUrl(appkey, appsecret, itemId, promoId, couponUrl, couponPrice, activityUrl string) (*md.ConvertedUrls, error) {
	args := map[string]interface{}{
		"appkey":       appkey,
		"secret_key":   appsecret,
		"gid":          itemId,
		"pid":          promoId,
		"coupon_url":   couponUrl,
		"activity_url": activityUrl,
	}
	fmt.Println("==========", args)
	resp, err := Send("jd", "get_buy_url", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			URL      string `json:"url"`
			ClickUrl string `json:"click_url"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: + " + string(resp) + " + err:" + err.Error())
	}
	hasCoupon := false
	if couponUrl != "" {
		hasCoupon = true
	}
	return &md.ConvertedUrls{
		ItemId:          itemId,
		URL:             tmp.Data.URL,
		ShortenURL:      tmp.Data.URL,
		NoOpenAppURL:    tmp.Data.URL,
		AppURL:          tmp.Data.URL,
		HasCoupon:       hasCoupon,
		CommissionRate:  couponPrice,
		WeChatMiniURL:   fmt.Sprintf(md.APPLET_JD_URL, tmp.Data.URL),
		WeChatMiniAPPID: md.APPLET_JD_ID,
		ClickUrl:        tmp.Data.ClickUrl,
	}, nil
}
