package zhimeng

import (
	"applet/app/utils/logx"
	"encoding/json"
)

func KuaishouLive(tikTokArgs map[string]interface{}) (*[]TikTokLiveData, error) {
	args := map[string]interface{}{
		"appkey":     tikTokArgs["appkey"],
		"secret_key": tikTokArgs["secret_key"],
		"page":       tikTokArgs["p"],
		"page_size":  tikTokArgs["size"],
		"num":        tikTokArgs["goods_num"],
		"keyword":    tikTokArgs["keyword"],
	}
	for k, v := range args {
		if v == nil || v == "<nil>" {
			args[k] = ""
		}
	}
	resp, err := Send("kuaishou", "getLive", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data []TikTokLiveData `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}
	return &tmp.Data, nil
}

func KuaishouLiveUrl(tikTokArgs map[string]interface{}) (*TikTokUrlData, error) {
	args := map[string]interface{}{
		"appkey":        tikTokArgs["appkey"],
		"secret_key":    tikTokArgs["secret_key"],
		"linkCarrierId": tikTokArgs["gid"],
		"comments":      tikTokArgs["external_info"],
		"linkType":      tikTokArgs["linkType"],
		"genPoster":     tikTokArgs["genPoster"],
	}
	resp, err := Send("kuaishou", "getUrls", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data TikTokUrlData `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}
	return &tmp.Data, nil
}
