package zhimeng

import (
	"applet/app/md"
	"applet/app/utils/logx"
	"encoding/json"
)

func GetThirdChargeMoney(ak, sk string) (*md.GetChargeMoney, error) {
	args := map[string]interface{}{
		"appkey":     ak,
		"secret_key": sk,
	}
	resp, err := Send("yr_phone", "balance", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	//fmt.Println(string(resp))
	var tmp struct {
		Data *md.GetChargeMoney `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: + " + string(resp) + " + err:" + err.Error())
	}
	return tmp.Data, nil
}

func ThirdBuyPhoneCharge(ak, sk, account, goodId, uid, oid, orderId, area string) (string, error) {
	args := map[string]interface{}{
		"appkey":     ak,
		"secret_key": sk,
		"id":         goodId,  // 商品ID 智盟的商品IsvcD
		"cardno":     account, // 直冲账号
		"zuid":       uid,     // 用户ID
		"l_id":       oid,     // 订单ID
		"oid":        orderId, // 订单号
		"area":       area,    // 地区 电费用
	}
	resp, err := Send("yr_phone", "pay", args)
	if err != nil {
		return "", err
	}
	//fmt.Println(string(resp))
	//return string(resp)
	var tmp struct {
		Msg     string `json:"msg"`
		Success int    `json:"success"`
		Data    struct {
			State string `json:"state"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return "", logx.Warn(err)
	}
	return tmp.Data.State, err
}
