package zhimeng

import (
	"applet/app/e"
	"applet/app/md"
	"applet/app/utils/logx"
	"encoding/json"
	"fmt"
)

// 创建推广位
var pvdList = map[string]string{
	md.PVD_JD:  md.PVD_JD,
	md.PVD_PDD: md.PVD_PDD,
	md.PVD_VIP: "wph",
}

// 需要参数euid, domain_id
func PromoIdCreate(appkey, appsecret, pvd, eUid, domainId, siteName, siteId string) (string, error) {
	method, ok := pvdList[pvd]
	// siteId京东必传
	if !ok || (pvd == "jd" && siteId == "") {
		return "", e.NewErrCode(e.ERR_INVALID_ARGS)
	}
	args := map[string]interface{}{
		"appkey":     appkey,
		"secret_key": appsecret,
		"pid":        eUid,
		"euid":       eUid,
		"domain_id":  domainId,
		"name":       siteName,
		"siteId":     siteId,
	}
	op := "create_pid"
	if pvd == md.PVD_PDD {
		op = "create_pid_new"
	}
	resp, err := Send(method, op, args)
	if err != nil {
		return "", logx.Warn(err)
	}
	return parsePid(pvd, resp)
}

// 二次请求时候才能获取到对方的pid, 这个??????
func parsePid(pvd string, resp []byte) (string, error) {
	var tmp struct {
		Data struct {
			Pid        string `json:"pid"`
			PddPid     string `json:"pdd_pid,omitempty"`
			JdPid      string `json:"jd_pid,omitempty"`
			StationPid string `json:"station_pid,omitempty"`
		} `json:"data"`
	}
	if err := json.Unmarshal(resp, &tmp); err != nil {
		return "", logx.Warn(err)
	}

	fmt.Println(string(resp), tmp)
	// 如果是唯品会的话,拿station_pid
	if pvd == md.PVD_VIP {
		return tmp.Data.StationPid, nil
	}
	return tmp.Data.Pid, nil
}
