package zhimeng

import (
	"encoding/json"

	"applet/app/md"
	"applet/app/utils/logx"
)

func TaobaoWordCreate(url, text string) (*md.TaobaoWord, error) {
	args := map[string]interface{}{
		"url":  url,
		"text": text,
	}
	resp, err := Send("tb", "create_tkl", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			Tkl    string `json:"tkl"`
			NewTkl string `json:"new_tkl"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}
	return &md.TaobaoWord{
		Text: tmp.Data.NewTkl,
		Code: tmp.Data.Tkl,
	}, nil
}

//解析口令
//keyword 关键词  pid 推广位
func TaobaoWordParsing(appkey, appsecret, keyword, pid string) (*md.TaobaoWordGid, error) {
	args := map[string]interface{}{
		"keyword":    keyword,
		"pid":        pid,
		"appkey":     appkey,
		"secret_key": appsecret,
	}
	resp, err := Send("tb", "new_tkl_gid", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			Gid string `json:"gid"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}
	return &md.TaobaoWordGid{
		Gid: tmp.Data.Gid,
	}, nil
}
