package zhimeng

import (
	"applet/app/md"
	"applet/app/utils"
	"applet/app/utils/logx"
	"encoding/json"
	"strconv"
)

func ToOrder365Url(appkey, appsecret string, user *md.User, method string, isShare int) (*md.OfficialRecommendUrl, error) {
	args := map[string]interface{}{
		"appkey":     appkey,
		"secret_key": appsecret,
		"is_share":   utils.IntToStr(isShare),
		"zuid":       strconv.Itoa(user.Info.Uid),
	}
	method = method + "Url"
	resp, err := Send("hw_365_pay", method, args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			Url string `json:"url"` //
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}
	return &md.OfficialRecommendUrl{
		Url: tmp.Data.Url,
	}, nil
}
