package zhimeng

import (
	"applet/app/md"
	"applet/app/utils"
	"applet/app/utils/logx"
	"encoding/json"
	"strconv"
)

func ToT3Url(appkey, appsecret string, user *md.User, mid string, activityId string, isShare int) (*md.OfficialRecommendUrl, error) {
	args := map[string]interface{}{
		"appkey":      appkey,
		"secret_key":  appsecret,
		"is_share":    utils.IntToStr(isShare),
		"zuid":        strconv.Itoa(user.Info.Uid),
		"mid":         mid,        //h5 mini
		"activity_id": activityId, //滴滴货运CPS推广3524 滴滴加油CPS推广3484 滴滴打车CPS推广3026
	}
	resp, err := Send("t3car", "getUrl", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			Alipay struct {
				AppID     string `json:"appId"`
				AppSource string `json:"appSource"`
				CodeLink  string `json:"codeLink"`
				Dsi       string `json:"dsi"`
				ShortURL  string `json:"shortUrl"`
			} `json:"alipay"`
			H5 struct {
				AppID     string `json:"appId"`
				AppSource string `json:"appSource"`
				CodeLink  string `json:"codeLink"`
				Dsi       string `json:"dsi"`
				ShortURL  string `json:"shortUrl"`
			} `json:"h5"`
			Mini struct {
				AppID     string `json:"appId"`
				AppSource string `json:"appSource"`
				CodeLink  string `json:"codeLink"`
				Dsi       string `json:"dsi"`
				ShortURL  string `json:"shortUrl"`
			} `json:"mini"`
			Poster string `json:"poster"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}
	return &md.OfficialRecommendUrl{
		Url:               tmp.Data.H5.ShortURL,
		Appid:             tmp.Data.Mini.AppID,
		Id:                tmp.Data.Mini.AppSource,
		WxQrcodeUrl:       "",
		WxMiniprogramPath: tmp.Data.Mini.ShortURL,
	}, nil
}
