package md

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/lib/comm_plan"
)

type CommissionRes struct {
	Data *SettleCommissionToGuide `json:"data"`
	Msg  string                   `json:"msg"`
}
type CommissionRes1 struct {
	Data map[string]*SettleCommissionToGuide `json:"data"`
	Msg  string                              `json:"msg"`
}
type SettleCommissionToGuide struct {
	Profit     float64           `json:"profit"`
	PvdFee     float64           `json:"pvd_fee"`
	SysFee     float64           `json:"sys_fee"`
	SubsidyFee float64           `json:"subsidy_fee"`
	LvUser     *comm_plan.LvUser `json:"lv_user"`
}

// LvUser 分佣返回结果
type LvUser struct {
	Uid         int // 用户ID
	Lv          int // 等级
	NewLv       int // 升级后等级 针对会员费分佣
	LevelWeight int // 权重

	Profit         float64 // 利润
	SubsidyFee     float64 // 补贴
	ProfitList     []*VirtualCoinCommission
	SubsidyFeeList []*VirtualCoinCommission

	/*IntegralProfit       float64 // 积分利润
	IntegralSubsidyFee   float64 // 积分补贴
	BlockIconsProfit     float64 // 区块币利润
	BlockIconsSubsidyFee float64 // 区块币补贴*/

	OwnbuyReturnType int     //0有返利 1没有返利
	Diff             int     // 与当前用户级别差
	ParentUser       *LvUser // 父用户
}

// 虚拟币分佣结构体
type VirtualCoinCommission struct {
	Cid string  `json:"cid"` // 虚拟币id
	Val float64 `json:"val"` // 数量
}

// CommissionReq 分佣请求结构体
type CommissionReq struct {
	CommissionParam  CommissionParam `json:"commission_param"`
	Uid              string          `json:"uid"`                 // 用户id
	IsShare          int             `json:"is_share"`            // 是否是分享
	Provider         string          `json:"provider"`            // 类型
	IsAllLevelReturn int             `json:"is_all_level_return"` // 是否返回所有层级
	GoodsId          string          `json:"goods_id,omitempty"`  // 批量请求用于标记是哪个商品
	OldLv            string          `json:"old_lv"`
	NewLv            string          `json:"new_lv"`
	OwnbuyReturnType int             `json:"ownbuy_return_type"` //自购是否返利 0返利 1不返利
	Oid              string          `json:"oid"`
	IsShowExtend     string          `json:"is_show_extend"`
}
type CommissionSelfAndShare struct {
	Commission      float64 `json:"commission"`
	ShareCommission float64 `json:"share_commission"`
}
type CommissionParam struct {
	GoodsPrice           string `json:"goods_price"`
	OldPrice             string `json:"old_price"`
	PaidPrice            string `json:"paid_price"`
	Commission           string `json:"commission"`
	CommissionRate       string `json:"commission_rate"`
	CouponPrice          string `json:"coupon_price"`
	WlGoodsPrice         string `json:"wl_goods_price"` //卷后价
	LowerPrice           string `json:"lower_price"`
	LowestCouponPrice    string `json:"lowestCouponPrice"`
	MinGroupPrice        string `json:"min_group_price"`
	TikTokTeamCommission string `json:"tik_tok_team_commission"`
	IsTikTokTeamOrder    string `json:"is_tik_tok_team_order"`
	DouyinBili           string `json:"douyin_bili"`
}
type CommissionFirstParam struct {
	CommissionParam  CommissionParam `json:"commission_param"`
	Uid              string          `json:"uid"`
	IsShare          int             `json:"is_share"`
	OldLv            string          `json:"old_lv"` //升级礼包读取的是升级前的等级
	NewLv            string          `json:"new_lv"` //升级礼包读取的是升级后的等级
	Provider         string          `json:"provider"`
	IsAllLevelReturn int             `json:"is_all_level_return"` // 是否返回所有层级
	GoodsId          string          `json:"goods_id,omitempty"`  // 用于标记是哪个商品的
	OwnbuyReturnType int             `json:"ownbuy_return_type"`  //自购是否返利 0返利 1不返利
	Oid              string          `json:"oid"`
	ShowLevel        string          `json:"show_level"`
	IsShowExtend     string          `json:"is_show_extend"`
	ServiceUid       string          `json:"service_uid"`
}
