package md

import (
	model2 "applet/app/db/model"
	"applet/app/lib/plan"
)

const UserWithdrawApplyExchange = "zhios.app.user.withdraw.apply.exchange"

const DouShenUserRegisterExchange = "zhios.doushen.user.register.exchange"
const FastReturnOrder = "zhios.order.fast.return.exchange"
const RechargeOrder = "zhios.recharge.order.exchange"
const Acquisition = "zhios.acquisition.exchange"
const UserUpLv = "zhios.user_up_lv.exchange"
const GuideStoreOrder = "zhios.guide_store.exchange"
const OrderFree = "zhios.order_free.exchange"
const UserValid = "zhios.user_valid.exchange"
const OrderBuckle = "zhios.order_buckle.exchange"
const OrderSettleTotal = "zhios.order_settle_total.exchange"
const OrderTotal = "zhios.order_total.exchange"
const UserRelate = "zhios.user_relate.exchange"

const GuideOrderTrackUpdate = "zhios.order_track_update.exchange"

const (
	UserRelateParam                                   = "user_relate"
	DouShenUserRegisterRoutKeyForOfficial             = "official"                 // 官方
	DouShenUserRegisterRoutKeyForOperationCenter      = "operation_center"         // 运营中心
	DouShenUserRegisterRoutKeyForMyRecommender        = "my_recommender"           // 我的推荐人
	DouShenUserRegisterRoutKeyForMyFans               = "my_fans"                  // 我的粉丝
	DouShenUserRegisterRoutKeyForUserRegisterCommUpLv = "user_register_comm_up_lv" // 用户注册自动升级(给推荐人)
	FastReturnOrderRoutKeyForOrderPay                 = "order_pay"
	FastReturnOrderRoutKeyForOrderRefund              = "order_refund"
	FastReturnOrderRoutKeyForOrderRefundSecond        = "order_refund_second"
	FastReturnOrderRoutKeyForOrderSuccess             = "order_success"
	RechargeOrderRoutKeyForOrderFail                  = "order_fail"
	RechargeOrderRoutKeyForOrderFailDev               = "order_fail_dev"
	AcquisitionRoutKeyForCondition                    = "condition"
	AcquisitionRoutKeyForUserValid                    = "user_valid"
	AcquisitionRoutKeyForUserValidDev                 = "user_valid_dev"
	AcquisitionRoutKeyForConditionDev                 = "acq_dev"
	GuideStoreRoutKeyForOrder                         = "guide_store_order"
	GuideStoreRoutKeyForOrderDev                      = "guide_store_order_dev"
	OrderBuckleRoutKeyForOrderDev                     = "order_buckle_dev"
	OrderBuckleRoutKeyForOrder                        = "order_buckle"
	OrderSettleTotalRoutKeyForOrder                   = "order_settle_total"
	OrderTotalRoutKeyForOrder                         = "order_total"
	OrderFreeRoutKeyForOrder                          = "order_free"
	OrderFreeRoutKeyForOrderdev                       = "order_free_dev"
	OrderTotalSecondRoutKeyForOrder                   = "order_total_second"
	UserUpLvRoutKey                                   = "user_up_lv"
	OrderHjyRoutKeyForOrder                           = "order_hjy"
	GuideOrderTrackUpdateRoutKeyForTb                 = "tb"
)
const OrderHjy = "zhios.order_hjy.exchange"

type ZhiosGuideStoreOrder struct {
	Uid          string `json:"uid"`
	Mid          string `json:"mid"`
	Oid          string `json:"oid"`
	StoreId      string `json:"store_id"`
	DeductPrice  string `json:"deduct_price"`
	ItemTitle    string `json:"item_title"`
	Pvd          string `json:"pvd"`
	SubsidyPrice string `json:"subsidy_price"`
	Fee          string `json:"fee"`
	State        string `json:"state"`
	Type         string `json:"type"`
	ItemId       string `json:"item_id"`
}
type ZhiosOrderFree struct {
	ItemId    string `json:"item_id"`
	SkuId     string `json:"sku_id"`
	OptPvd    string `json:"opt_pvd"`
	OrderType string `json:"order_type"`
	Pid       string `json:"pid"`
	Oid       string `json:"oid"`
	Uid       string `json:"uid"`
	Mid       string `json:"mid"`
}
type DouShenUserRegisterMessageStructForOfficial struct {
	MasterId string `json:"master_id"`
	Phone    int64  `json:"phone"`
	Uid      int64  `json:"uid"`
}
type DouShenUserRegisterMessageStructForMyFans struct {
	MasterId string `json:"master_id"`
	Phone    int64  `json:"phone"`
	Uid      int64  `json:"uid"`
}
type DouShenUserRegisterMessageStructForMyRecommender struct {
	MasterId         string `json:"master_id"`
	Phone            int64  `json:"phone"`
	Uid              int64  `json:"uid"`
	RecommenderUid   int64  `json:"recommender_uid"`
	RecommenderPhone string `json:"recommender_phone"`
}
type DouShenUserRegisterMessageStructForOperationCenter struct {
	MasterId             string `json:"master_id"`
	Phone                int64  `json:"phone"`
	Uid                  int64  `json:"uid"`
	OperationCenterUid   int64  `json:"operation_center_uid"`
	OperationCenterPhone string `json:"operation_center_phone"`
}
type DouShenUserRegisterMessageStructForCommUpLv struct {
	MasterId string `json:"master_id"`
	Uid      int64  `json:"uid"`
}

type ZhiosFatReturnOrderPay struct {
	Uid    string `json:"uid"`
	Mid    string `json:"mid"`
	Oid    string `json:"oid"`
	Name   string `json:"name"`
	Prd    string `json:"prd"`
	Amount int    `json:"amount"`
}

type ZhiosRechargeOrderPay struct {
	Uid                 string `json:"uid"`
	Mid                 string `json:"mid"`
	Oid                 string `json:"oid"`
	WxappletFilepathUrl string `json:"wxapplet_filepath_url"`
	DomainUrl           string `json:"domain_url"`
}
type ZhiosAcquisition struct {
	Uid string `json:"uid"`
	Id  string `json:"id"`
	Mid string `json:"mid"`
}
type ZhiosOrderBuckle struct {
	Oid string `json:"oid"`
	Mid string `json:"mid"`
	Uid string `json:"uid"`
}

type ZhiosOrderTrackUpdateRoutKeyForTb struct {
	Pvd        string                   `json:"pvd"`
	OrderData  *[]OrderInfo             `json:"order_data"`
	Opts       map[string]*plan.PlanOpt `json:"opts"`
	SecondOpts map[string]*plan.PlanOpt `json:"second_opts"`
	DbName     string                   `json:"db_name"`
}

type ZhiosOrderTrackCreateRoutKeyForTb struct {
	Pvd        string                   `json:"pvd"`
	OrderData  *[]OrderInfo             `json:"order_data"`
	Opts       map[string]*plan.PlanOpt `json:"opts"`
	SecondOpts map[string]*plan.PlanOpt `json:"second_opts"`
	DbName     string                   `json:"db_name"`
}

type ZhiosOrderTrackRefundRoutKeyForTbPart struct {
	PidToUser map[string]*UserPid      `json:"pid_to_user"`
	NewOrds   map[string]OrderInfo     `json:"new_ords"`
	Opts      map[string]*plan.PlanOpt `json:"opts"`
	DbName    string                   `json:"db_name"`
	Ord       model2.OrdList           `json:"ord"`
}

type ZhiosOrderTrackRefundRoutKeyForTbAll struct {
	ReturnMoneyType string         `json:"return_money_type"`
	DbName          string         `json:"db_name"`
	Ord             model2.OrdList `json:"ord"`
}
