package md

type IndexRecommendList struct {
	// BarTitleList                []BarTitle      `json:"bar_title_list"`
	Provider          string          `json:"provider"`
	RecommendGoodList []RecommendGood `json:"good"`
	Count             string          `json:"count"`
}

type BarTitle struct {
	ActiveColor string `json:"active_color"`
	Title       string `json:"title"`
	SubTitle    string `json:"subtitle"`
}

type RecommendGood struct {
	Provider             string                 `json:"provider"`
	ProviderName         string                 `json:"provider_name"`
	GoodID               string                 `json:"good_id"`
	GoodImage            string                 `json:"good_image"`
	Title                string                 `json:"good_title"`
	ShopName             string                 `json:"shop_name"`
	Coupon               string                 `json:"coupon"`
	Commission           string                 `json:"commission"`
	MarketPrice          string                 `json:"market_price"`
	CurrentPrice         string                 `json:"current_price"`
	InOrderCount         string                 `json:"inorder_count"`
	InOrderCountNum      string                 `json:"inorder_count_num"`
	PVD                  string                 `json:"pvd"`
	IsCollect            int                    `json:"is_collect"`
	IsCoupons            int                    `json:"is_coupons"`
	IsShare              int                    `json:"is_share"`
	Video                string                 `json:"video"`
	VideoHeight          int                    `json:"video_height"`
	ShopAvatar           string                 `json:"shop_avatar"`
	CoinList             []CoinList             `json:"coin_list"`
	MarqueeList          []*Marquee             `json:"marquee_list"`
	DetailData           *ProductDetailResponse `json:"detail_data"`
	CommissionRate       string                 `json:"commission_rate"`
	PublicCommissionRate string                 `json:"public_commission_rate"`
	PvdIcon              string                 `json:"pvd_icon"`
}

type CoinList struct {
	CoinId    string `json:"coin_id"`
	CoinName  string `json:"coin_name"`
	CoinValue string `json:"coin_value"`
	CoinBili  string `json:"coin_bili"`
}
type Marquee struct {
	Name      string `json:"name"`
	Content   string `json:"content"`
	AvatarUrl string `json:"avatar_url"`
}

type RecommendGoodStyle struct {
	ProviderNameColor           string `json:"provider_name_color"`
	ProviderNameBackgroundColor string `json:"provider_name_background_color"`
	ShopNameColor               string `json:"shop_name_color"`
	ShopIcon                    string `json:"shop_icon"`
	CouponBackgroundColor       string `json:"coupon_background_color"`
	CouponColor                 string `json:"coupon_font_color"`
	CommissionBackgroundColor   string `json:"commission_background_color"`
	CommissionColor             string `json:"commission_font_color"`
	MarketPriceColor            string `json:"market_price_color"`
	CurrentPriceColor           string `json:"current_price_color"`
}

//JDResponse 推荐猜你喜欢的返回的结构
type JDResponse struct {
	Code       int              `json:"code"`
	Data       []JDResponseItem `json:"data"`
	Message    string           `json:"message"`
	RequestID  string           `json:"requestId"`
	TotalCount int              `json:"totalCount"`
}

//JDResponseItem is JDResponseItem 结构
type JDResponseItem struct {
	BrandCode    string `json:"brandCode"`
	BrandName    string `json:"brandName"`
	CategoryInfo struct {
		Cid1     int    `json:"cid1"`
		Cid1Name string `json:"cid1Name"`
		Cid2     int    `json:"cid2"`
		Cid2Name string `json:"cid2Name"`
		Cid3     int    `json:"cid3"`
		Cid3Name string `json:"cid3Name"`
	} `json:"categoryInfo"`
	Comments       int `json:"comments"`
	CommissionInfo struct {
		Commission          float64 `json:"commission"`
		CommissionShare     float64 `json:"commissionShare"`
		PlusCommissionShare float64 `json:"plusCommissionShare"`
	} `json:"commissionInfo"`
	CouponInfo struct {
		CouponList []CouponListItem `json:"couponList"`
	} `json:"couponInfo"`
	DeliveryType      int     `json:"deliveryType"`
	ForbidTypes       []int   `json:"forbidTypes"`
	GoodCommentsShare float64 `json:"goodCommentsShare"`
	ImageInfo         struct {
		ImageList []struct {
			URL string `json:"url"`
		} `json:"imageList"`
		WhiteImage string `json:"whiteImage"`
	} `json:"imageInfo"`
	InOrderCount30Days    int    `json:"inOrderCount30Days"`
	InOrderCount30DaysSku int    `json:"inOrderCount30DaysSku"`
	IsHot                 int    `json:"isHot"`
	JxFlags               []int  `json:"jxFlags"`
	Owner                 string `json:"owner"`
	PinGouInfo            struct {
		PingouPrice   float64 `json:"pingouPrice"`
		PingouTmCount int     `json:"pingouTmCount"`
	} `json:"pinGouInfo"`
	PriceInfo struct {
		LowestPrice        float64 `json:"lowestPrice"`
		LowestPriceType    int     `json:"lowestPriceType"`
		Price              float64 `json:"price"`
		LowerPrices        string  `json:"lower_prices"`
		WlGoodsPrices      string  `json:"wl_goods_prices"`
		LowestCouponPrices string  `json:"lowest_coupon_prices"`
	} `json:"priceInfo"`
	PromotionInfo struct {
		ClickURL string `json:"clickURL"`
	} `json:"promotionInfo"`
	ResourceInfo struct {
		EliteID   int    `json:"eliteId"`
		EliteName string `json:"eliteName"`
	} `json:"resourceInfo"`
	ShopInfo struct {
		ShopID    int     `json:"shopId"`
		ShopLevel float64 `json:"shopLevel"`
		ShopName  string  `json:"shopName"`
	} `json:"shopInfo"`
	SkuID     int64  `json:"skuId"`
	SkuName   string `json:"skuName"`
	Spuid     int64  `json:"spuid"`
	VideoInfo struct {
	} `json:"videoInfo"`
}

// CouponListItem is CouponList item
type CouponListItem struct {
	BindType     int     `json:"bindType"`
	Discount     float64 `json:"discount"`
	GetEndTime   int64   `json:"getEndTime"`
	GetStartTime int64   `json:"getStartTime"`
	IsBest       int     `json:"isBest"`
	Link         string  `json:"link"`
	PlatformType int     `json:"platformType"`
	Quota        float64 `json:"quota"`
	UseEndTime   int64   `json:"useEndTime"`
	UseStartTime int64   `json:"useStartTime"`
}
