package svc

import (
	"applet/app/md"
	"applet/app/utils/logx"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/lib/comm_plan"
	md2 "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule"
	"github.com/jinzhu/copier"
	"xorm.io/xorm"
)

//获取每个商品的佣金
func GetMoreRebateResult(eg *xorm.Engine, dbName, returnMoneyType string, reqList []md.CommissionFirstParam, goodsList []map[string]string) (map[string]*comm_plan.SettleCommissionToGuide, map[string]interface{}) {
	var commissionListArr = make(map[string]*comm_plan.SettleCommissionToGuide, 0)
	var returnListArr = make(map[string]interface{}, 0)
	if returnMoneyType == "1" {
		returnListArr, _ = BatchGetReturnMoneyByGoodsApi(eg, dbName, goodsList)
	} else {
		commissionListArr, _ = BatchGetCommissionByCommApi(eg, dbName, reqList)
	}
	return commissionListArr, returnListArr
}
func GetMoreRebateResultService(eg *xorm.Engine, dbName, returnMoneyType string, reqList []md.CommissionFirstParam, goodsList []map[string]string) (map[string]*comm_plan.SettleCommissionToGuide, map[string]interface{}) {
	var commissionListArr = make(map[string]*comm_plan.SettleCommissionToGuide, 0)
	var returnListArr = make(map[string]interface{}, 0)
	commissionListArr, _ = BatchGetOrderCommissionByCommApiService(eg, dbName, reqList)
	return commissionListArr, returnListArr
}

// 批量计算分佣
func BatchGetOrderCommissionByCommApiService(eg *xorm.Engine, masterId string, reqs []md.CommissionFirstParam) (map[string]*comm_plan.SettleCommissionToGuide, error) {

	var req []*md2.CommissionFirstParam
	for _, v := range reqs {
		var tmp = md2.CommissionFirstParam{}
		copier.Copy(&tmp, v)
		req = append(req, &tmp)
	}
	commissionList, err := rule.BatchGetCommissionByOrderService(eg, masterId, req)
	if err != nil {
		return nil, logx.Error(err)
	}

	return commissionList, nil
}
