package svc

import (
	"applet/app/cfg"
	"applet/app/db"
	"crypto/tls"
	"encoding/json"
	"fmt"
	"github.com/tidwall/gjson"
	"io"
	"io/ioutil"
	"net/http"
	"strings"
	"time"
	"xorm.io/xorm"
)

// 批量计算分佣
func BatchGetReturnMoneyByGoodsApi(eg *xorm.Engine, masterId string, req []map[string]string) (map[string]interface{}, error) {
	result := BatchGetReturnMoney(eg, masterId, req)
	return result, nil
}
func BatchGetReturnMoney(eg *xorm.Engine, masterId string, req []map[string]string) map[string]interface{} {
	littlePocket := db.SysCfgFindWithDb(eg, masterId, "little_pocket_basic_data")
	returnMoneyType := "0"
	if littlePocket != nil && gjson.Get(littlePocket["little_pocket_basic_data"], "return_money_type").String() == "1" {
		returnMoneyType = "1"
	}
	if returnMoneyType == "0" {
		return nil
	}
	if len(req) == 0 {
		return nil
	}
	var host string
	host = cfg.AppComm.URL + "/api/v1/inComm/littlePocketCustomize/getMoreCommission"
	tr := &http.Transport{
		MaxIdleConnsPerHost: 200,
		MaxIdleConns:        200,
		MaxConnsPerHost:     200,
		TLSClientConfig:     &tls.Config{InsecureSkipVerify: true},
	}
	client := &http.Client{
		Timeout:   5 * time.Second,
		Transport: tr,
	}
	byte1, _ := json.Marshal(req)
	fmt.Println(string(byte1))
	req1, _ := http.NewRequest("POST", host, strings.NewReader(string(byte1)))
	req1.Header.Set("master_id", masterId)
	req1.Header.Set("platform", "ios")
	req1.Header.Set("Content-Type", "application/json")
	resp, err := (client).Do(req1)
	if err != nil || resp == nil {
		if resp != nil {
			_, _ = io.Copy(ioutil.Discard, resp.Body)
		}
		return nil
	}
	defer resp.Body.Close()
	respByte, _ := ioutil.ReadAll(resp.Body)

	if len(respByte) == 0 {
		return nil
	}
	var serverResp map[string]interface{}
	err = json.Unmarshal(respByte, &serverResp)
	if err != nil || serverResp == nil {

		return nil
	}
	if serverResp["data"] == nil {
		if serverResp["msg"] != "" {
			return nil
		}
		return nil
	}
	list := serverResp["data"].(map[string]interface{})
	return list
}
