package svc

import (
	"fmt"
	"github.com/tidwall/gjson"
	"strings"
	"xorm.io/xorm"

	"applet/app/db"
	"applet/app/md"
	"applet/app/utils"
)

//判断字符串是否在数组里
func in(target int64, str_array []int64) bool {
	for _, element := range str_array {
		if target == element {
			return true
		}
	}
	return false
}

func parsePids(eg *xorm.Engine, masterId, pvd string, pids []string) map[int]*md.UserPid {
	var (
		user = map[int]*md.UserPid{}
		uids []int
	)

	switch pvd {
	case md.PVD_TB:
		var (
			sharePids           []int64
			cloudPids           []int64
			selfPids            []int64
			freePids            []int64
			relationfreePids    []int64
			trelationfreePids   []int64
			secondFreePids      []int64
			actselfPids         []int64
			wechatActSharePids  []int64
			wechatActPids       []int64
			tljRelationFreePids []int64
			tljFreePids         []int64
			wechatActNewPids    []string
		)
		var types = "activity_order"
		for _, v := range pids {
			s := strings.Split(v, "_")
			if len(s) == 3 {
				if s[0] == "wechatactselfnew" {
					wechatActNewPids = append(wechatActNewPids, s[1]+"_"+s[2])
				}
				continue
			}
			if len(s) != 2 {
				continue
			}
			if s[0] == "share" {
				sharePids = append(sharePids, utils.StrToInt64(s[1]))
			} else if s[0] == "cloud" {
				cloudPids = append(cloudPids, utils.StrToInt64(s[1]))
			} else if s[0] == "self" {
				selfPids = append(selfPids, utils.StrToInt64(s[1]))
			} else if s[0] == "free" {
				freePids = append(freePids, utils.StrToInt64(s[1]))
			} else if s[0] == "relationfree" {
				relationfreePids = append(relationfreePids, utils.StrToInt64(s[1]))
			} else if s[0] == "ttljfree" {
				trelationfreePids = append(trelationfreePids, utils.StrToInt64(s[1]))
			} else if s[0] == "seFree" {
				secondFreePids = append(secondFreePids, utils.StrToInt64(s[1]))
			} else if s[0] == "tljfree" {
				tljFreePids = append(tljFreePids, utils.StrToInt64(s[1]))
			} else if s[0] == "actself" {
				actselfPids = append(actselfPids, utils.StrToInt64(s[1]))
			} else if s[0] == "tljrelationfree" {
				tljRelationFreePids = append(tljRelationFreePids, utils.StrToInt64(s[1]))
				freeCfg := db.SysCfgGetWithDb(eg, masterId, "newcomers_free_cfg")
				if freeCfg == "" {
					continue
				}
				types = gjson.Get(freeCfg, "tlj_relation_taobao_pid").String()
			} else if s[0] == "wechatactself" {
				wechatActPids = append(wechatActPids, utils.StrToInt64(s[1]))
			} else if s[0] == "wechatactshare" {
				wechatActSharePids = append(wechatActSharePids, utils.StrToInt64(s[1]))
			}
		}
		//小程序查询用户id的
		wechatActUsers, err := db.DealOrderUserByTbPids(eg, wechatActPids, types)
		if wechatActUsers != nil && err == nil {
			for _, vv := range *wechatActUsers {
				fmt.Println(vv)
				orderType := md.OrderTypeWechatActSelf
				result := in(vv.RelationId, wechatActSharePids)
				if result == true {
					orderType = md.OrderTypeWechatActShare
				}
				user[vv.Uid] = &md.UserPid{Pid: utils.Int64ToStr(vv.RelationId), Uid: vv.Uid, OrderType: orderType, Lv: 0}
			}
		}
		taobaoCfg, err := db.SysUnionByTaobaoByUseByAuth(eg, masterId)
		if taobaoCfg != nil {
			for _, v := range wechatActNewPids {
				split := strings.Split(v, "_")
				if len(split) == 2 {
					//小程序查询用户id的
					wechatActNewUsers := db.TaobaoRelationOrderUserByTbPids(eg, split[0], split[1], taobaoCfg.Id)
					if wechatActNewUsers != nil {
						orderType := md.OrderTypeWechatActSelfNew
						user[wechatActNewUsers.Uid] = &md.UserPid{Pid: v, Uid: wechatActNewUsers.Uid, OrderType: orderType, Lv: 0}
					}
				}
			}
		}
		//淘礼金渠道订单
		tljRelationFreeUsers, err := db.DealOrderUserByTbPids(eg, tljRelationFreePids, types)
		if tljRelationFreeUsers != nil && err == nil {
			for _, vv := range *tljRelationFreeUsers {
				fmt.Println(vv)
				orderType := md.OrderTypeTljRelationFree
				result := in(vv.RelationId, tljRelationFreePids)
				if result == true {
					//orderType = md.OrderTypeTljFree
				}
				user[vv.Uid] = &md.UserPid{Pid: utils.Int64ToStr(vv.RelationId), Uid: vv.Uid, OrderType: orderType, Lv: 0}
			}
		}
		shareUsersNew, err := db.DbsUserProfileFindByTbPidsNew(eg, sharePids, true)
		if shareUsersNew != nil && err == nil {
			for _, vv := range *shareUsersNew {
				user[vv.Uid] = &md.UserPid{Pid: utils.Int64ToStr(vv.RelationId), Uid: vv.Uid, OrderType: md.OrderTypeShare, Lv: 0}
			}
		}
		shareUsers, err := db.DbsUserProfileFindByTbPids(eg, sharePids, true)
		if shareUsers != nil && err == nil {
			for _, vv := range *shareUsers {
				user[vv.Uid] = &md.UserPid{Pid: utils.Int64ToStr(vv.AccTaobaoShareId), Uid: vv.Uid, OrderType: md.OrderTypeShare, Lv: 0}
			}
		}

		cloudUsersNew, err := db.DbsUserProfileFindByTbPidsNew(eg, cloudPids, true)
		if cloudUsersNew != nil && err == nil {
			for _, vv := range *cloudUsersNew {
				user[vv.Uid] = &md.UserPid{Pid: utils.Int64ToStr(vv.RelationId), Uid: vv.Uid, OrderType: 10, Lv: 0}
			}
		}
		cloudUsers, err := db.DbsUserProfileFindByTbPids(eg, cloudPids, true)
		if cloudUsers != nil && err == nil {
			for _, vv := range *cloudUsers {
				user[vv.Uid] = &md.UserPid{Pid: utils.Int64ToStr(vv.AccTaobaoShareId), Uid: vv.Uid, OrderType: 10, Lv: 0}
			}
		}

		selfUsersNew, err := db.DbsUserProfileFindByTbPidsNew(eg, selfPids, false)
		if selfUsersNew != nil && err == nil {
			for _, v := range *selfUsersNew {
				user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.SpecialId), Uid: v.Uid, OrderType: md.OrderTypeSelf, Lv: 0}
			}
		}
		selfUsers, err := db.DbsUserProfileFindByTbPids(eg, selfPids, false)
		if selfUsers != nil && err == nil {
			for _, v := range *selfUsers {
				user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.AccTaobaoSelfId), Uid: v.Uid, OrderType: md.OrderTypeSelf, Lv: 0}
			}
		}
		rfreeUsersNew, err := db.DbsUserProfileFindByTbPidsNew(eg, relationfreePids, true)
		if rfreeUsersNew != nil && err == nil {
			for _, v := range *rfreeUsersNew {
				user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.RelationId), Uid: v.Uid, OrderType: 15, Lv: 0}
			}
		}
		rfreeUsers, err := db.DbsUserProfileFindByTbPids(eg, relationfreePids, true)
		if rfreeUsers != nil && err == nil {
			for _, v := range *rfreeUsers {
				user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.AccTaobaoShareId), Uid: v.Uid, OrderType: 15, Lv: 0}
			}
		}

		trfreeUsersNew, err := db.DbsUserProfileFindByTbPidsNew(eg, trelationfreePids, false)
		if trfreeUsersNew != nil && err == nil {
			for _, v := range *trfreeUsersNew {
				user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.RelationId), Uid: v.Uid, OrderType: 16, Lv: 0}
			}
		}
		trfreeUsers, err := db.DbsUserProfileFindByTbPids(eg, trelationfreePids, false)
		if trfreeUsers != nil && err == nil {
			for _, v := range *trfreeUsers {
				user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.AccTaobaoShareId), Uid: v.Uid, OrderType: 16, Lv: 0}
			}
		}

		freeUsersNew, err := db.DbsUserProfileFindByTbPidsNew(eg, freePids, false)
		if freeUsersNew != nil && err == nil {
			for _, v := range *freeUsersNew {
				user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.SpecialId), Uid: v.Uid, OrderType: md.OrderTypeFree, Lv: 0}
			}
		}
		freeUsers, err := db.DbsUserProfileFindByTbPids(eg, freePids, false)
		if freeUsers != nil && err == nil {
			for _, v := range *freeUsers {
				user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.AccTaobaoSelfId), Uid: v.Uid, OrderType: md.OrderTypeFree, Lv: 0}
			}
		}
		tljFreeUsersNew, err := db.DbsUserProfileFindByTbPidsNew(eg, tljFreePids, false)
		if tljFreeUsersNew != nil && err == nil {
			for _, v := range *tljFreeUsersNew {
				user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.SpecialId), Uid: v.Uid, OrderType: md.OrderTypeTljFree, Lv: 0}
			}
		}
		tljFreeUsers, err := db.DbsUserProfileFindByTbPids(eg, tljFreePids, false)
		if tljFreeUsers != nil && err == nil {
			for _, v := range *tljFreeUsers {
				user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.AccTaobaoSelfId), Uid: v.Uid, OrderType: md.OrderTypeTljFree, Lv: 0}
			}
		}
		if actselfPids != nil {
			//活动自购 因为用的是渠道id 要这样判断下
			actselfUsersNew, err := db.DbsUserProfileFindByTbPidsNew(eg, actselfPids, true)
			if actselfUsersNew != nil && err == nil {
				for _, v := range *actselfUsersNew {
					user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.RelationId), Uid: v.Uid, OrderType: md.OrderTypeActSelf, Lv: 0}
				}
			}
			actselfUsers, err := db.DbsUserProfileFindByTbPids(eg, actselfPids, true)
			if actselfUsers != nil && err == nil {
				for _, v := range *actselfUsers {
					user[v.Uid] = &md.UserPid{Pid: utils.Int64ToStr(v.AccTaobaoShareId), Uid: v.Uid, OrderType: md.OrderTypeActSelf, Lv: 0}
				}
			}
		}

	case md.PVD_JD, md.PVD_PDD, md.PVD_JDOwn:
		var (
			jdPddSelfUid  []int
			jdPddShareUid []int
			jdPddFreeUid  []int
			jdPddCloudUid []int
		)
		var user1 = map[int]*md.UserPid{}
		for _, v := range pids {
			s := strings.Split(v, "_")
			id := 0
			orderType := md.OrderTypeSelf
			types := "self"
			isContinue := 1
			if len(s) == 2 {
				id = utils.StrToInt(s[1])
				types = s[0]
				isContinue = 0
			}
			if len(s) >= 6 {
				id = utils.StrToInt(s[5])
				types = s[4]
				isContinue = 0
			}
			if isContinue == 1 {
				continue
			}
			if types == "share" {
				orderType = md.OrderTypeShare
				jdPddShareUid = append(jdPddShareUid, id)
			} else if types == "free" {
				orderType = md.OrderTypeFree
				jdPddFreeUid = append(jdPddFreeUid, id)
			} else if types == "cloud" {
				orderType = 10
				jdPddCloudUid = append(jdPddCloudUid, id)
			} else {
				jdPddSelfUid = append(jdPddSelfUid, id)
			}
			user1[id] = &md.UserPid{Pid: v, Uid: id, OrderType: orderType, Lv: 0}
		}
		fmt.Println(jdPddShareUid)
		//有些可能数据库没有
		if jdPddSelfUid != nil {
			//活动自购 因为用的是渠道id 要这样判断下
			users, err := db.DbsUserProfileFindByIDs(eg, jdPddSelfUid...)
			if users != nil && err == nil {
				for _, v := range *users {
					user[v.Uid] = user1[v.Uid]
				}
			}
		}
		//有些可能数据库没有
		if jdPddShareUid != nil {
			//活动自购 因为用的是渠道id 要这样判断下
			users, err := db.DbsUserProfileFindByIDs(eg, jdPddShareUid...)
			fmt.Println(users)

			if users != nil && err == nil {
				for _, v := range *users {
					user[v.Uid] = user1[v.Uid]
				}
			}
			fmt.Println(user)

		}
		fmt.Println("endsssss")
		//有些可能数据库没有
		if jdPddFreeUid != nil {
			//活动自购 因为用的是渠道id 要这样判断下
			users, err := db.DbsUserProfileFindByIDs(eg, jdPddFreeUid...)
			if users != nil && err == nil {
				for _, v := range *users {
					user[v.Uid] = user1[v.Uid]
				}
			}
		}
		//有些可能数据库没有
		if jdPddCloudUid != nil {
			//活动自购 因为用的是渠道id 要这样判断下
			users, err := db.DbsUserProfileFindByIDs(eg, jdPddCloudUid...)
			if users != nil && err == nil {
				for _, v := range *users {
					user[v.Uid] = user1[v.Uid]
				}
			}
		}

	case md.PVD_KL, md.PVD_SN, md.PVD_VIP:
		for _, v := range pids {
			s := strings.Split(v, "_")
			if len(s) < 4 {
				continue
			}
			id := utils.StrToInt(s[3])
			orderType := md.OrderTypeSelf
			if s[2] == "share" {
				orderType = md.OrderTypeShare
			}
			if s[2] == "free" {
				orderType = md.OrderTypeFree
			}
			if s[2] == "cloud" {
				orderType = 10
			}
			_, ok := user[id]
			orderTypes := make([]string, 0)
			if ok {
				orderTypes = user[id].Pids
				if len(orderTypes) == 0 {
					orderTypes = make([]string, 0)
				}
			}
			orderTypes = append(orderTypes, v)
			user[id] = &md.UserPid{Pids: orderTypes, Uid: id, OrderType: orderType, Lv: 0}
		}
	default:
		for _, v := range pids {

			s := strings.Split(v, "_")
			if len(s) < 2 && pvd == md.PVD_DUOMAI {
				s = []string{"self", v}
			}
			if len(s) < 2 {
				continue
			}
			id := utils.StrToInt(s[1])
			orderType := md.OrderTypeSelf
			if s[0] == "share" {
				orderType = md.OrderTypeShare
			}
			if s[0] == "free" {
				orderType = md.OrderTypeFree
			}
			if s[0] == "seFree" {
				orderType = 11
			}
			if s[0] == "shareSeFree" {
				orderType = 12
			}
			if s[0] == "moreFree" {
				orderType = 13
			}
			_, ok := user[id]
			orderTypes := make([]string, 0)
			if ok {
				orderTypes = user[id].Pids
				if len(orderTypes) == 0 {
					orderTypes = make([]string, 0)
				}
			}
			orderTypes = append(orderTypes, v)
			user[id] = &md.UserPid{Pids: orderTypes, Pid: v, Uid: id, OrderType: orderType, Lv: 0}
		}
	}
	for _, v := range user {
		uids = append(uids, v.Uid)
	}
	u, err := db.DbsUserFindByIds(eg, uids)
	if err != nil || u == nil {
		return nil
	}
	for _, v := range *u {
		user[v.Uid].Lv = v.Level
	}
	return user
}
