package svc

import (
	"applet/app/cfg"
	"applet/app/lib/push"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_o2o_business.git/o2o"
	db2 "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/lib/comm_plan"
	md2 "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"fmt"
	"strings"
	"time"

	"xorm.io/xorm"

	"applet/app/db"
	"applet/app/db/model"
	"applet/app/lib/plan"
	"applet/app/md"
	"applet/app/utils"
)

//公共判断订单是否要绑定用户
func commCheckUser(eg *xorm.Engine, existOrd model.OrdList, ords map[string]md.OrderInfo, pvd string, pidToUser map[string]*md.UserPid, opts map[string]*plan.PlanOpt, secondOpts map[string]*plan.PlanOpt, dbName string, isCheck bool, returnMoneyType string) {
	pid := ords[existOrd.PvdOid].Pid
	if utils.InArr(pvd, []string{md.PVD_TB, "ele", md.PVD_TB12, md.PVD_TB13, md.PVD_TB14, md.PVD_TB3, md.PVD_TBBYPAY, md.PVD_TBBYCREATETIME, md.PVD_TBBYSETTLE}) {
		//如果是淘宝要处理下类型拿用户
		for k := range pidToUser {
			pidTmp := strings.Split(pid, "_")
			if len(pidTmp) == 2 {
				if strings.Contains(k, pidTmp[1]) && pidTmp[1] != "" {
					pid = k
				}
			}
		}
	}
	if strings.Contains(existOrd.PvdPid, "free") || strings.Contains(pid, "free") || existOrd.PriceType > 0 || existOrd.SecondPriceType > 0 || existOrd.ThirdPriceType > 0 {

		fmt.Println("免单不走这里")
		return
	}
	if existOrd.OrderFormType < 0 {
		return
	}
	//判断一下是不是已经结算过的，如果结算过并且佣金不一致要扣钱
	oldCommission := fmt.Sprintf("%2f", existOrd.BenefitAll)
	if utils.StrToFloat64(oldCommission) != ords[existOrd.PvdOid].Commission && (existOrd.SettleAt > 0 || existOrd.State == 5) && existOrd.IsRefund == 0 && pvd != md.PVD_FREE {
		var commission = ords[existOrd.PvdOid].Commission
		existOrd.BenefitAll = commission
		existOrd.BenefitAll = utils.FloatFormat(existOrd.BenefitAll, 2)
		pidToUser[pid] = &md.UserPid{Uid: existOrd.Uid, OrderType: existOrd.OrderType}
		newOrds := map[string]md.OrderInfo{}
		newOrds[existOrd.PvdOid] = md.OrderInfo{Pid: pid, Pvd: existOrd.Pvd, OrderType: existOrd.OrderType, PvdOid: existOrd.PvdOid, Commission: existOrd.BenefitAll}
		if existOrd.IsFastSign == 0 {
			DeductMoney(eg, existOrd, newOrds, existOrd.Pvd, pidToUser, opts, dbName, "佣金变化")
		}
		return
	}
	if ords[existOrd.PvdOid].Commission <= 0 {
		//如果没佣金就不改
		return
	}
	existOrd.BenefitAll = utils.FloatFormat(existOrd.BenefitAll, 2)
	pvdList1 := []string{md.PVD_ELM, md.PVD_T3_CAR, md.PVD_WALLACE, md.PVD_TOURISM, md.PVD_DELIVERY, md.PVD_NEAR, md.PVD_FLOWERCAKE, md.PVD_PIZZA, md.PVD_HWMOVIE, md.PVD_CINEMA, md.PVD_KFC, md.PVD_HEYTEA, md.PVD_BURGERKING, md.PVD_STARBUCKS, md.PVD_MCDONALD, md.PVD_NAYUKI, md.PVD_LUCKIN, md.PVD_TO_KFC, md.PVD_PAGODA, md.PVD_KING_FLOWER, md.PVD_DIDI_ONLINE_CAR, md.PVD_DIDI_FREIGHT, md.PVD_DIDI_ENERGY, md.PVD_OILSTATION, md.PVD_DIDI_CHAUFFEUR}
	pvdList := []string{"tik_tok_team_order", md.PVD_JDOwn, md.PVD_JD, "csjp", "csjp_live", md.PVD_TIKTOKLIFE, md.PVD_ELM, md.PVD_STATIONMEITUANLM, md.PVD_MEITUANLMSTART, md.PVD_MEITUANLM, md.PVD_MEITUAN, md.PVD_T3_CAR, md.PVD_WALLACE, md.PVD_TOURISM, md.PVD_DELIVERY, md.PVD_NEAR, md.PVD_FLOWERCAKE, md.PVD_TIKTOK, md.PVD_PIZZA, md.PVD_TIKTOKLIVE, md.PVD_KUAISHOU, md.PVD_KUAISHOULIVE, md.PVD_MEITUAN, md.PVD_MEITUANLM, md.PVD_CINEMA, md.PVD_KFC, md.PVD_HEYTEA, md.PVD_BURGERKING, md.PVD_STARBUCKS, md.PVD_MCDONALD, md.PVD_NAYUKI, md.PVD_LUCKIN, md.PVD_TO_KFC, md.PVD_PAGODA, md.PVD_KING_FLOWER, md.PVD_DIDI_ONLINE_CAR, md.PVD_DIDI_FREIGHT, md.PVD_DIDI_ENERGY, md.PVD_OILSTATION, md.PVD_DIDI_CHAUFFEUR}
	fmt.Println("===============================111111111111111111111111111111")
	fmt.Println((existOrd.Uid == 0 && pid != "" && pidToUser[pid] != nil && (pvd == md.PVD_TB || pvd == "ele")))
	fmt.Println((existOrd.BenefitAll != ords[existOrd.PvdOid].Commission || (ords[existOrd.PvdOid].Commission == 0 && existOrd.UserCommission > 0)))
	fmt.Println((pvd == md.PVD_TB || pvd == md.PVD_TBBYCREATETIME || pvd == md.PVD_TBBYSETTLE))
	fmt.Println((existOrd.BenefitAll == 0 && utils.InArr(pvd, pvdList)))
	fmt.Println(isCheck)
	fmt.Println("===============================111111111111111111111111111111")
	var relateAmount float64 = 0
	var isVipSet = 1
	if pvd == md.PVD_VIP {
		ordRelate, _ := db.OrderListRelateByOidFirst(eg, utils.Int64ToStr(existOrd.OrdId))
		if ordRelate != nil {
			relateAmount = ordRelate.Amount
			if relateAmount == 0 && ordRelate.Mode == "public_platoon" {
				isVipSet = 0 //为了公排模式条件不触发
			}
		}
	}
	isTikTokTrue := false
	if existOrd.IsTikTokTeamOrder == 0 && existOrd.IsTikTokTeamOrder != ords[existOrd.PvdOid].IsTikTokTeamOrder {
		isTikTokTrue = true
	}
	if pvd == md.PVD_PDD && existOrd.State < 4 && existOrd.BenefitAll < ords[existOrd.PvdOid].Commission && existOrd.BenefitAll > 0 {
		isTikTokTrue = true
	}
	if existOrd.UserCommission > 0 && existOrd.BenefitAll > 0 {
		ordRelate, _ := db.OrderListRelateByOidFirst(eg, utils.Int64ToStr(existOrd.OrdId))
		if ordRelate != nil && ordRelate.Amount == 0 {
			isTikTokTrue = true
		}
	}
	isTodelete := false
	if (existOrd.BenefitAll == 0 && ords[existOrd.PvdOid].Commission > 0) && utils.InArr(pvd, pvdList1) {
		isCheck = true
		isTodelete = true
	}
	if isTikTokTrue || (pvd == md.PVD_VIP && existOrd.BenefitAll > 0 && isVipSet == 1 && (existOrd.UserCommission == 0 || relateAmount == 0)) || (existOrd.Uid == 0 && pid != "" && pidToUser[pid] != nil && (pvd == md.PVD_TB || pvd == "ele")) || ((pvd == md.PVD_TB12 || pvd == md.PVD_TB13 || pvd == md.PVD_TB14 || pvd == md.PVD_TB3 || pvd == md.PVD_TB || pvd == md.PVD_TBBYPAY || pvd == md.PVD_TBBYCREATETIME || pvd == md.PVD_TBBYSETTLE || pvd == md.PVD_JD || pvd == md.PVD_VIP || pvd == md.PVD_PDD || pvd == md.PVD_ELM) && (existOrd.BenefitAll != ords[existOrd.PvdOid].Commission || (ords[existOrd.PvdOid].Commission == 0 && existOrd.UserCommission > 0))) || ((existOrd.BenefitAll != ords[existOrd.PvdOid].Commission || existOrd.BenefitAll == 0) && utils.InArr(pvd, pvdList)) || isCheck == true {
		if !strings.Contains(pid, "cloud") && !strings.Contains(pid, "share") && !strings.Contains(pid, "self") && !strings.Contains(pid, "free") && !strings.Contains(pid, "actself") && !strings.Contains(pid, "wechatactselfnew") && !strings.Contains(pid, "wechatactself") && !strings.Contains(pid, "wechatactshare") {
			return
		}

		fmt.Println("===============================2222")

		oldUid := existOrd.Uid
		var user *md.UserPid
		var oid = existOrd.OrdId
		user = pidToUser[pid]
		fmt.Println(user)
		if user != nil { //用户不为空才判断
			if oid == 0 {
				oid = utils.StrToInt64(utils.OrderUUID(user.Uid))
				existOrd.OrdId = oid
			}

			newPvds := pvd
			//判断是饿了么的
			if ords[existOrd.PvdOid].Pvd == "ele" {
				newPvds = "ele"
			}
			if utils.InArr(pvd, []string{md.PVD_KuaishouOwn, md.PVD_KuaishouOwnCreate}) {
				newPvds = md.PVD_KUAISHOU
				if ords[existOrd.PvdOid].Pvd == "Live" {
					newPvds = md.PVD_KUAISHOULIVE
				}
			}
			newOpts := opts[newPvds]
			secondOpt := secondOpts[newPvds]

			if pvd == "oil" && newOpts == nil {
				newOpts = opts["oilstation"]
			}
			if existOrd.OrderFormType == 1 && opts[md.PVD_JDOwn] != nil {
				newOpts = opts[md.PVD_JDOwn]
				newPvds = md.PVD_JDOwn
			}
			if existOrd.OrderFormType == 1 && secondOpts[md.PVD_JDOwn] != nil {
				secondOpt = secondOpts[md.PVD_JDOwn]
			}
			if newOpts != nil && newOpts.Mode == "public_platoon" && isCheck == false { //如果是公牌 并且不是没有分佣记录的 不能改了
				return
			}
			var lvUser *comm_plan.LvUser
			var secondLvUser *comm_plan.LvUser

			var pvdFee float64
			var sysFee float64
			var subsidyFee float64
			var err error
			var subsidyRate float64
			var uid = 0
			var profit float64 = 0
			var returnProfit float64 = 0
			var returnMoneyOne map[string]interface{}
			var selfRate float64 = 0
			uid = user.Uid
			isShare := 0
			if ords[existOrd.PvdOid].OrderType == md.OrderTypeShare || ords[existOrd.PvdOid].OrderType == md.OrderTypeWechatActShare {
				isShare = 1
			}
			var commissionReqList = make([]md.CommissionFirstParam, 0)
			var secondCommissionReqList = make([]md.CommissionFirstParam, 0)

			var returnMoneyReqList = make([]map[string]string, 0)
			IsTikTokTeamOrder := ords[existOrd.PvdOid].IsTikTokTeamOrder
			TikTokTeamCommission := ords[existOrd.PvdOid].TikTokTeamCommission
			TikTokTeamRealCommission := ords[existOrd.PvdOid].TikTokTeamRealCommission
			TikTokTeamCommissionParam := TikTokTeamCommission
			if utils.StrToFloat64(ords[existOrd.PvdOid].TikTokTeamRealCommission) > 0 {
				TikTokTeamCommissionParam = ords[existOrd.PvdOid].TikTokTeamRealCommission
			}
			if existOrd.IsTikTokTeamOrder == 1 && ords[existOrd.PvdOid].IsTikTokTeamOrder == 0 {
				IsTikTokTeamOrder = existOrd.IsTikTokTeamOrder
				TikTokTeamCommission = existOrd.TikTokTeamCommission
				TikTokTeamRealCommission = existOrd.TikTokTeamRealCommission
				if utils.StrToFloat64(existOrd.TikTokTeamRealCommission) > 0 {
					TikTokTeamCommissionParam = existOrd.TikTokTeamRealCommission
				}
			}
			if (pvd == "tikTok" || pvd == "csjp") && IsTikTokTeamOrder == 1 && opts["tikTokTeam"] != nil && opts["tikTokTeam"].PlanCommissionId > 0 {
				newOpts = opts["tikTokTeam"]
			}
			if pvd == "kuaishou" && IsTikTokTeamOrder == 1 && opts["kuaishouTeam"] != nil && opts["kuaishouTeam"].PlanCommissionId > 0 {
				newOpts = opts["kuaishouTeam"]
			}
			if (pvd == "tikTok" || pvd == "csjp") && IsTikTokTeamOrder == 1 && secondOpts["tikTokTeam"] != nil && secondOpts["tikTokTeam"].PlanCommissionId > 0 {
				secondOpt = secondOpts["tikTokTeam"]
			}
			if pvd == "kuaishou" && IsTikTokTeamOrder == 1 && secondOpts["kuaishouTeam"] != nil && secondOpts["kuaishouTeam"].PlanCommissionId > 0 {
				secondOpt = secondOpts["kuaishouTeam"]
			}
			req := md.CommissionFirstParam{
				CommissionParam: md.CommissionParam{
					Commission:           utils.Float64ToStr(ords[existOrd.PvdOid].Commission),
					PaidPrice:            utils.Float64ToStr(ords[existOrd.PvdOid].PaidPrice),
					OldPrice:             utils.Float64ToStr(ords[existOrd.PvdOid].PaidPrice),
					TikTokTeamCommission: TikTokTeamCommissionParam,
					IsTikTokTeamOrder:    utils.IntToStr(IsTikTokTeamOrder),
				},
				Uid:              utils.IntToStr(uid),
				IsShare:          isShare,
				Provider:         newPvds,
				IsAllLevelReturn: 1,
				Oid:              existOrd.PvdOid,
			}
			commissionReqList = append(commissionReqList, req)
			if existOrd.ServiceUid > 0 && secondOpt != nil {
				req.ServiceUid = utils.IntToStr(existOrd.ServiceUid)
				secondCommissionReqList = append(secondCommissionReqList, req)
			}
			returnMoneyReq := map[string]string{
				"commission":    utils.Float64ToStr(ords[existOrd.PvdOid].Commission),
				"goods_price":   utils.Float64ToStr(ords[existOrd.PvdOid].PaidPrice),
				"uid":           utils.IntToStr(uid),
				"provider":      newPvds,
				"is_share":      utils.IntToStr(isShare),
				"is_return_all": "1",
				"key_value":     existOrd.PvdOid,
			}
			returnMoneyReqList = append(returnMoneyReqList, returnMoneyReq)
			commissionListArr, returnListArr := GetMoreRebateResult(eg, dbName, returnMoneyType, commissionReqList, returnMoneyReqList)
			secondCommissionListArr, _ := GetMoreRebateResultService(eg, dbName, returnMoneyType, secondCommissionReqList, returnMoneyReqList)

			if returnMoneyType == "0" {
				//调用公共的分佣
				commissionList := commissionListArr[existOrd.PvdOid]
				pvdFee = commissionList.PvdFee
				sysFee = commissionList.SysFee
				subsidyFee = commissionList.SubsidyFee
				lvUser = commissionList.LvUser
				profit = commissionList.Profit
				secondCommissionList := secondCommissionListArr[existOrd.PvdOid]
				if secondCommissionList != nil {
					secondLvUser = secondCommissionList.LvUser
				}
			} else {
				returnMoneyList := returnListArr[existOrd.PvdOid]
				var ok = true
				returnMoneyOne, ok = returnMoneyList.(map[string]interface{})
				if returnMoneyOne != nil && ok {
					returnProfit = utils.AnyToFloat64(returnMoneyOne["self_commission"])
					if isShare == 1 {
						returnProfit = utils.AnyToFloat64(returnMoneyOne["share_commission"])
					}
				}
			}

			//判断下这个等级有么有设置
			if newOpts.UserRate != nil {
				for k, item := range newOpts.UserRate {
					if k == 0 {
						selfRate = item.SelfRate
						subsidyRate = item.SubsidyShareRate
						if ords[existOrd.PvdOid].OrderType == 0 {
							subsidyRate = item.SubsidySelfRate
						}
					}
					if k == user.Lv {
						selfRate = item.SelfRate
						selfRate = item.SelfRate
						subsidyRate = item.SubsidyShareRate
						if ords[existOrd.PvdOid].OrderType == 0 {
							subsidyRate = item.SubsidySelfRate
						}
					}
				}
			}
			if newPvds == md.PVD_JDOwn {
				newPvds = md.PVD_JD
			}
			oldBenefitAll := existOrd.BenefitAll
			oldUserCommission := existOrd.UserCommission
			existOrd.SubsidyFee = subsidyFee
			existOrd.UserReturnMoney = returnProfit
			existOrd.SubsidyRate = subsidyRate
			if existOrd.IsFastSign == 0 {
				existOrd.UserCommission = profit
				existOrd.UserCommissionRate = selfRate
				if existOrd.BenefitAll == 0 {
					existOrd.BenefitAll = ords[existOrd.PvdOid].Commission
				}
				if existOrd.BenefitAll != ords[existOrd.PvdOid].Commission {
					existOrd.BenefitAll = ords[existOrd.PvdOid].Commission
					existOrd.PaidPrice = ords[existOrd.PvdOid].PaidPrice
				}
			}
			existOrd.PlanCommissionId = newOpts.PlanCommissionId
			existOrd.PvdCommission = pvdFee
			existOrd.PvdCommissionRate = newOpts.PvdRate
			existOrd.SysCommission = sysFee
			existOrd.SysCommissionRate = newOpts.SysRate
			existOrd.PlanCommissionId = newOpts.PlanCommissionId
			existOrd.UpdateAt = int(time.Now().Unix())
			existOrd.IsTikTokTeamOrder = IsTikTokTeamOrder
			existOrd.TikTokTeamCommission = TikTokTeamCommission
			existOrd.TikTokTeamRealCommission = TikTokTeamRealCommission

			existOrd.Uid = uid
			existOrd.BenefitList = SerializeLvUser(CalcLvUserFee(lvUser))
			_, err = db.OrderListByUpdateOrd(eg, &existOrd)
			if err != nil {
				fmt.Println("========用户信息1==========" + existOrd.PvdOid)
				fmt.Println(err)
				return
			}
			// TODO 塞入对应订单关系
			fmt.Println("========用户信息==========" + existOrd.PvdOid)
			fmt.Println("========分佣==========", returnMoneyType)
			isDelete := false
			if isTikTokTrue || (pvd == md.PVD_VIP && oldBenefitAll > 0 && isVipSet == 1 && (oldUserCommission == 0 || relateAmount == 0)) || ((oldBenefitAll != ords[existOrd.PvdOid].Commission) || (oldUserCommission > 0 && ords[existOrd.PvdOid].Commission == 0)) || ((oldBenefitAll != ords[existOrd.PvdOid].Commission || oldBenefitAll == 0) && utils.InArr(pvd, pvdList)) {
				isDelete = true
			}
			if isTodelete {
				isDelete = true
			}
			if existOrd.IsFastSign > 0 {
				isDelete = false
			}
			mode := ""
			if newOpts != nil {
				mode = newOpts.Mode
			}
			// TODO 塞入对应订单关系
			if lvUser != nil && returnMoneyType == "0" {
				OrderRelateInsert(eg, oid, newPvds, existOrd.CreateAt, lvUser, &existOrd, dbName, isDelete, mode, "0")
			} else if returnMoneyType == "1" {
				OrderReturnMoneyRelateInsert(eg, oid, newPvds, existOrd.CreateAt, returnMoneyOne, &existOrd, dbName, isDelete)
			}
			if secondLvUser != nil && returnMoneyType == "0" {
				OrderRelateInsertService(eg, oid, newPvds, existOrd.CreateAt, secondLvUser, &existOrd, dbName, isDelete, mode, "0")
			}
			if oldUid == 0 && uid > 0 { //写入区域代理订单
				//商家分佣
				args := map[string]string{
					"commission": utils.Float64ToStr(utils.FloatFormat(existOrd.BenefitAll, 6)), // 总佣金
					"bili":       utils.Float64ToStrByPrec(newOpts.MerchantRate, 4),             //	抽成 除以100之后的
					"uid":        utils.IntToStr(uid),                                           //	 用户id
					"oid":        utils.Int64ToStr(oid),                                         // 订单号
					"pvd":        existOrd.Pvd,                                                  // 渠道
				}
				o2o.AddStoreCommission(eg, args)
				var req = &md.InsertRegionalAgentOrdBelongData{
					Uid:           uid,
					Pvd:           md.PVD_GUIDE,
					CommPvd:       md.PVD_COMMON,
					Commission:    utils.Float64ToStr(utils.FloatFormat(existOrd.BenefitAll, 6)),
					OrderId:       oid,
					RegionRate:    newOpts.RegionRate,
					GlobalRate:    newOpts.GlobalRate,
					RegionSubRate: newOpts.RegionSubRate,
					Status:        "0",
				}
				//if mode == "lv_ds_check" && lvUser != nil {
				//	req.Commission = utils.Float64ToStrByPrec(lvUser.MinProfit, 8)
				//}
				go SaveOrderByCommApi(eg, dbName, req)
				//查询优惠券使用记录
				if existOrd.State != 4 {
					commCheckCoupon(eg, uid, existOrd.ItemId, 0, 1, existOrd.Pvd, utils.Int64ToStr(existOrd.OrdId))
				}
				commCheckCoupon(eg, uid, existOrd.ItemId, 0, 1, existOrd.Pvd, utils.Int64ToStr(existOrd.OrdId))

			}
		}
	}
}
func commCheckCoupon(eg *xorm.Engine, uid int, itemId string, state, newState int, pvd, oid string) {
	goodsType := ""
	if utils.InArr(pvd, []string{md.PVD_TB, md.PVD_TM, md.PVD_JD, md.PVD_PDD, md.PVD_VIP, md.PVD_SN, md.PVD_KL, md.PVD_KUAISHOU, md.PVD_TIKTOK}) == false {
		return
	}
	//查询优惠券使用记录
	couponList, _ := db.CouponUserOrdByGidAscBatch(eg, uid, itemId, state, goodsType, pvd)
	if couponList != nil {
		couponAll, _ := db.CouponUserOrdByGidAscBatchALL(eg, uid, itemId, state, couponList.Batch, goodsType, pvd)
		if couponAll != nil {
			for _, cv := range *couponAll {
				//更新使用状态
				cv.RefundState = newState
				if cv.Oid == "" {
					cv.Oid = oid
				}
				db.CouponUserOrdByUpdate(eg, &cv, "refund_state,oid")
			}
		}
	}
}
func commRefundCoupon(eg *xorm.Engine, uid int, itemId string, state, newState int, pvd string) {
	goodsType := ""
	if pvd == "oil" {
		goodsType = "oil"
	}
	//查询优惠券使用记录
	couponList, _ := db.CouponUserOrdByGidAscBatch(eg, uid, itemId, state, goodsType, pvd)
	if couponList != nil {
		couponAll, _ := db.CouponUserOrdByGidAscBatchALL(eg, uid, itemId, state, couponList.Batch, goodsType, pvd)
		if couponAll != nil {
			for _, cv := range *couponAll {
				//更新使用状态
				cv.RefundState = newState
				db.CouponUserOrdByUpdate(eg, &cv, "refund_state")
			}
		}
	}
}

// 免单记录修改
func OrderRelateInsertCommService(eg *xorm.Engine, oid int64, pvd string, createTime int, lvUser *comm_plan.LvUser, newOrd *model.OrdList, masterId string, mode string) []*model.OrdListRelate {
	var datas []*model.OrdListRelate
	if lvUser == nil {
		return datas
	}
	level := 0
	fmt.Println("关系链---"+utils.Int64ToStr(oid)+"---"+pvd+"---", utils.SerializeStr(lvUser))
	var ownSubsidyFee float64 = 0
	ownSubsidyFee1, ok := lvUser.OwnSubsidyFeeList["0"]
	if ok {
		ownSubsidyFee = ownSubsidyFee1
	}
	profit := utils.FloatFormat(lvUser.Profit+lvUser.SubsidyFee+ownSubsidyFee, 9)
	data := []*model.OrdListRelate{{Oid: oid, Uid: lvUser.Uid, Amount: profit, AdditionalSubsidy: utils.Float64ToStrByPrec(lvUser.AdditionalSubsidy, 9), Pvd: pvd, CreateAt: createTime, Level: level, Mode: mode, ExtendType: 8}}
	for lvUser.ParentUser != nil {
		lvUser = lvUser.ParentUser
		fmt.Println(lvUser)
		level = level + 1
		profit = utils.FloatFormat(lvUser.Profit+lvUser.SubsidyFee, 9)
		var additionalSubsidy float64 = 0
		if utils.InArr(mode, []string{"lv_winery", "public_platoon"}) {
			profit = utils.FloatFormat(lvUser.Profit, 6)
			additionalSubsidy = lvUser.SubsidyFee
		}
		if lvUser.Uid == 0 {
			continue
		}
		data = append(data, &model.OrdListRelate{
			Oid:               oid,
			Uid:               lvUser.Uid,
			Amount:            profit,
			Pvd:               pvd,
			CreateAt:          createTime,
			Level:             level,
			Mode:              mode,
			AdditionalSubsidy: utils.Float64ToStrByPrec(additionalSubsidy, 9),
			ExtendType:        8,
		})
	}
	return data
}
func OrderRelateInsertComm(eg *xorm.Engine, oid int64, pvd string, createTime int, lvUser *comm_plan.LvUser, newOrd *model.OrdList, masterId string, mode string) []*model.OrdListRelate {
	var datas []*model.OrdListRelate
	if lvUser == nil {
		return datas
	}
	level := 0
	fmt.Println("关系链---"+utils.Int64ToStr(oid)+"---"+pvd+"---", utils.SerializeStr(lvUser))
	var ownSubsidyFee float64 = 0
	ownSubsidyFee1, ok := lvUser.OwnSubsidyFeeList["0"]
	if ok {
		ownSubsidyFee = ownSubsidyFee1
	}
	profit := utils.FloatFormat(lvUser.Profit+lvUser.SubsidyFee+ownSubsidyFee, 9)
	data := []*model.OrdListRelate{{Oid: oid, Uid: lvUser.Uid, Amount: profit, AdditionalSubsidy: utils.Float64ToStrByPrec(lvUser.AdditionalSubsidy, 9), Pvd: pvd, CreateAt: createTime, Level: level, Mode: mode, ExtendType: lvUser.ExtendType}}
	for lvUser.ParentUser != nil {
		lvUser = lvUser.ParentUser
		fmt.Println(lvUser)
		level = level + 1
		profit = utils.FloatFormat(lvUser.Profit+lvUser.SubsidyFee, 9)
		var additionalSubsidy float64 = 0
		if utils.InArr(mode, []string{"lv_winery", "public_platoon"}) {
			profit = utils.FloatFormat(lvUser.Profit, 6)
			additionalSubsidy = lvUser.SubsidyFee
		}
		if lvUser.Uid == 0 {
			continue
		}
		data = append(data, &model.OrdListRelate{
			Oid:               oid,
			Uid:               lvUser.Uid,
			Amount:            profit,
			Pvd:               pvd,
			CreateAt:          createTime,
			Level:             level,
			Mode:              mode,
			AdditionalSubsidy: utils.Float64ToStrByPrec(additionalSubsidy, 9),
			ExtendType:        lvUser.ExtendType,
		})
	}
	return data
}
func OrderRelateInsert(eg *xorm.Engine, oid int64, pvd string, createTime int, lvUser *comm_plan.LvUser, newOrd *model.OrdList, masterId string, isDelete bool, mode string, isNew string) {

	if lvUser == nil {
		return
	}
	uid := lvUser.Uid
	if uid == 0 {
		return
	}
	oldLvUser := lvUser
	oldLevel := 0
	data := OrderRelateInsertComm(eg, oid, pvd, createTime, lvUser, newOrd, masterId, mode)
	fmt.Println("=====================写入明细", newOrd.PvdOid)
	fmt.Println(data)

	if data == nil || len(data) == 0 {
		return
	}
	fmt.Println("=====================写入明细1", newOrd.PvdOid)
	fmt.Println(isDelete)
	//先删掉
	if isDelete {
		if newOrd.IsTotal == 1 {
			var ordRelate = make([]model.OrdListRelate, 0)
			eg.Where("oid=?", newOrd.OrdId).Find(&ordRelate)
			now := time.Unix(int64(newOrd.CreateAt), 0).Format("200601")
			nowDay := time.Unix(int64(newOrd.CreateAt), 0).Format("20060102")
			if len(ordRelate) > 0 {
				isDeduct := 0
				for _, v := range ordRelate {
					if v.Amount == 0 && utils.StrToFloat64(v.AdditionalSubsidy) == 0 {
						continue
					}
					var userStatistics model.UserMonthAmount
					eg.Where("uid=? and date=?", v.Uid, now).Get(&userStatistics)
					if userStatistics.Id != 0 {
						userStatistics.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(userStatistics.Amount)-v.Amount-utils.StrToFloat64(v.AdditionalSubsidy), 4)
						eg.Where("id=?", userStatistics.Id).Cols("amount").Update(&userStatistics)
					}
					if v.CreateAt > 1711086661 {
						var userStatistics1 model.UserDayAmount
						eg.Where("uid=? and date=?", v.Uid, nowDay).Get(&userStatistics1)
						if userStatistics1.Id != 0 {
							userStatistics1.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(userStatistics1.Amount)-v.Amount-utils.StrToFloat64(v.AdditionalSubsidy), 4)
							eg.Where("id=?", userStatistics1.Id).Cols("amount").Update(&userStatistics1)
						}
					}
					var userStatistics1 model.UserWaitAmount
					eg.Where("uid=? ", v.Uid).Get(&userStatistics1)
					if userStatistics1.Id != 0 {
						userStatistics1.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(userStatistics1.Amount)-v.Amount-utils.StrToFloat64(v.AdditionalSubsidy), 4)
						eg.Where("id=?", userStatistics1.Id).Cols("amount").Update(&userStatistics1)
					}
					isDeduct = 1
				}
				if isDeduct == 1 {
					if newOrd.State == 4 {
						newOrd.IsTotal = 2
					} else {
						newOrd.IsTotal = 0
					}
					eg.Where("pvd_oid=?", newOrd.PvdOid).Cols("is_total").Update(newOrd)
				}
			}
		}
		fmt.Println("=====================写入明细2", newOrd.PvdOid)
		if pvd == md.PVD_JDOwn {
			db.OrderRelateDeleteByOid(eg, oid, md.PVD_JD)
			db.VirtualCoinOrderRelateDeleteByOid(eg, oid, md.PVD_JD)
		}
		if pvd == md.PVD_JD {
			db.OrderRelateDeleteByOid(eg, oid, md.PVD_JDOwn)
			db.VirtualCoinOrderRelateDeleteByOid(eg, oid, md.PVD_JDOwn)
		}
		db.OrderRelateDeleteByOid(eg, oid, pvd)
		db.VirtualCoinOrderRelateDeleteByOid(eg, oid, pvd)
	}
	if masterId == "68747754" && pvd == "taobao" {
		fmt.Println("========================", utils.SerializeStr(data))
	}
	//后写入
	err := db.DbInsertBatch(eg, data)
	fmt.Println("=====================写入明细3", newOrd.PvdOid)
	fmt.Println(err)
	fmt.Println("=====================写入明细4", newOrd.PvdOid)
	if err != nil {
		return
	} else if lvUser.ProfitList != nil {
		// 插入虚拟币数据
		vcrData := CombineVirtualCoinRelateData(oldLvUser, oid, pvd, oldLevel, mode)
		db.DbInsertBatch(eg, vcrData)
		if mode == "lv_integral_release" && utils.InArr(utils.IntToStr(newOrd.State), []string{"0", "1", "2", "3"}) {
			AddVirCoin(eg, oid, vcrData, masterId)
		}
		//for _, item := range vcrData {
		//	fmt.Println(item)
		//}
		//if err2 != nil {
		//	return
		//}
	}
	if lvUser.TikTokOwnSubsidyFeeList != nil {
		db.TikTokTeamOrderRelateDeleteByOid(eg, oid, pvd)
		var teamData []model.TikTokTeamOrderRelate
		TikTokTeamCommission := newOrd.TikTokTeamCommission
		if utils.StrToFloat64(newOrd.TikTokTeamRealCommission) > 0 {
			TikTokTeamCommission = newOrd.TikTokTeamRealCommission
		}
		for k, v := range lvUser.TikTokOwnSubsidyFeeList {
			tmp := model.TikTokTeamOrderRelate{
				CoinId:     utils.StrToInt(k),
				Uid:        uid,
				Amount:     utils.Float64ToStrByPrec(v, 8),
				Oid:        utils.Int64ToStr(oid),
				Time:       time.Now(),
				Commission: TikTokTeamCommission,
				Pvd:        pvd,
			}
			teamData = append(teamData, tmp)
		}
		db.DbInsertBatch(eg, &teamData)
	}
	if newOrd.IsFastSign == 0 {
		FastReturnCreateOrder(eg, newOrd.Uid, utils.Int64ToStr(newOrd.OrdId), masterId)
	}
	newOrds, _ := db.OrderListByOid(eg, newOrd.PvdOid)
	if newOrds == nil {
		return
	}
	//后台推送
	appName := db.SysCfgGetWithDb(eg, masterId, "app_name_cn")
	if uid == 0 {
		return
	}
	users, err := db.UserFindByID(eg, uid)
	if users == nil || err != nil {
		return
	}
	fmt.Println("-=========用户=========")
	fmt.Println(lvUser.Uid)
	fmt.Println(users)
	if newOrds.IsSendMsg == 1 { //不发送
		return
	}
	newOrds.IsSendMsg = 1
	_, _ = db.OrdUpdateOne(eg, newOrds)
	IsShowPoint := db.SysCfgGetWithDb(eg, masterId, "is_show_point")
	CommissionPrec := db.SysCfgGetWithDb(eg, masterId, "commission_prec")
	for _, v := range data {
		var args md.PushParams
		args.AppName = appName
		args.Nickname = users.Nickname
		args.RegNickname = users.Nickname
		args.RegPhone = users.Phone
		args.Pvd = md.PVD_LIST[newOrds.Pvd]
		args.Payment = utils.Float64ToStr(newOrd.PaidPrice)
		args.OrderNickname = users.Nickname
		args.OrderNo = newOrd.PvdOid
		args.OrderTime = time.Unix(int64(newOrd.CreateAt), 0).Format("2006-1-02 15:04:05")
		args.Fcommission = GetCommissionPrecEg(utils.Float64ToStrByPrec(v.Amount, 8), CommissionPrec, IsShowPoint)
		args.Money = GetCommissionPrecEg(utils.Float64ToStrByPrec(v.Amount, 8), CommissionPrec, IsShowPoint)
		args.Uid = v.Uid
		args.MasterId = masterId
		args.PushType = "order_team"
		if v.Level == 0 && newOrd.OrderType == 0 {
			args.PushType = "order_self"
		}
		if v.Level == 0 && newOrd.OrderType == 1 {
			args.PushType = "order_share"
		}
		if v.Level == 0 || v.Amount > 0 {
			fmt.Println("----开始----")
			fmt.Println(args)
			push.CommAddPush(eg, args)
		}
	}

}
func OrderRelateInsertService(eg *xorm.Engine, oid int64, pvd string, createTime int, lvUser *comm_plan.LvUser, newOrd *model.OrdList, masterId string, isDelete bool, mode string, isNew string) {

	if lvUser == nil {
		return
	}
	uid := lvUser.Uid
	if uid == 0 {
		return
	}
	oldLvUser := lvUser
	oldLevel := 0
	data := OrderRelateInsertCommService(eg, oid, pvd, createTime, lvUser, newOrd, masterId, mode)
	fmt.Println("=====================写入明细", newOrd.PvdOid)
	fmt.Println(data)

	if data == nil || len(data) == 0 {
		return
	}
	fmt.Println("=====================写入明细1", newOrd.PvdOid)
	fmt.Println(isDelete)
	//先删掉
	if isDelete {
		fmt.Println("=====================写入明细2", newOrd.PvdOid)
		if pvd == md.PVD_JDOwn {
			db.OrderRelateDeleteByOidService(eg, oid, md.PVD_JD)
			db.VirtualCoinOrderRelateDeleteByOidService(eg, oid, md.PVD_JD)
		}
		if pvd == md.PVD_JD {
			db.OrderRelateDeleteByOidService(eg, oid, md.PVD_JDOwn)
			db.VirtualCoinOrderRelateDeleteByOidService(eg, oid, md.PVD_JDOwn)
		}
		db.OrderRelateDeleteByOidService(eg, oid, pvd)
		db.VirtualCoinOrderRelateDeleteByOidService(eg, oid, pvd)
	}
	if masterId == "68747754" && pvd == "taobao" {
		fmt.Println("========================", utils.SerializeStr(data))
	}
	//后写入
	err := db.DbInsertBatch(eg, data)
	fmt.Println("=====================写入明细3", newOrd.PvdOid)
	fmt.Println(err)
	fmt.Println("=====================写入明细4", newOrd.PvdOid)
	if err != nil {
		return
	} else if lvUser.ProfitList != nil {
		// 插入虚拟币数据
		vcrData := CombineVirtualCoinRelateDataService(oldLvUser, oid, pvd, oldLevel, mode)
		db.DbInsertBatch(eg, vcrData)
		if mode == "lv_integral_release" && utils.InArr(utils.IntToStr(newOrd.State), []string{"0", "1", "2", "3"}) {
			AddVirCoin(eg, oid, vcrData, masterId)
		}
		//for _, item := range vcrData {
		//	fmt.Println(item)
		//}
		//if err2 != nil {
		//	return
		//}
	}
	if lvUser.TikTokOwnSubsidyFeeList != nil {
		db.TikTokTeamOrderRelateDeleteByOid(eg, oid, pvd)
		var teamData []model.TikTokTeamOrderRelate
		TikTokTeamCommission := newOrd.TikTokTeamCommission
		if utils.StrToFloat64(newOrd.TikTokTeamRealCommission) > 0 {
			TikTokTeamCommission = newOrd.TikTokTeamRealCommission
		}
		for k, v := range lvUser.TikTokOwnSubsidyFeeList {
			tmp := model.TikTokTeamOrderRelate{
				CoinId:     utils.StrToInt(k),
				Uid:        uid,
				Amount:     utils.Float64ToStrByPrec(v, 8),
				Oid:        utils.Int64ToStr(oid),
				Time:       time.Now(),
				Commission: TikTokTeamCommission,
				Pvd:        pvd,
			}
			teamData = append(teamData, tmp)
		}
		db.DbInsertBatch(eg, &teamData)
	}
	if newOrd.IsFastSign == 0 {
		FastReturnCreateOrder(eg, newOrd.Uid, utils.Int64ToStr(newOrd.OrdId), masterId)
	}
	newOrds, _ := db.OrderListByOid(eg, newOrd.PvdOid)
	if newOrds == nil {
		return
	}
	//后台推送
	appName := db.SysCfgGetWithDb(eg, masterId, "app_name_cn")
	if uid == 0 {
		return
	}
	users, err := db.UserFindByID(eg, uid)
	if users == nil || err != nil {
		return
	}
	fmt.Println("-=========用户=========")
	fmt.Println(lvUser.Uid)
	fmt.Println(users)
	if newOrds.IsSendMsg == 1 { //不发送
		return
	}
	newOrds.IsSendMsg = 1
	_, _ = db.OrdUpdateOne(eg, newOrds)
	IsShowPoint := db.SysCfgGetWithDb(eg, masterId, "is_show_point")
	CommissionPrec := db.SysCfgGetWithDb(eg, masterId, "commission_prec")
	for _, v := range data {
		var args md.PushParams
		args.AppName = appName
		args.Nickname = users.Nickname
		args.RegNickname = users.Nickname
		args.RegPhone = users.Phone
		args.Pvd = md.PVD_LIST[newOrds.Pvd]
		args.Payment = utils.Float64ToStr(newOrd.PaidPrice)
		args.OrderNickname = users.Nickname
		args.OrderNo = newOrd.PvdOid
		args.OrderTime = time.Unix(int64(newOrd.CreateAt), 0).Format("2006-1-02 15:04:05")
		args.Fcommission = GetCommissionPrecEg(utils.Float64ToStrByPrec(v.Amount, 8), CommissionPrec, IsShowPoint)
		args.Money = GetCommissionPrecEg(utils.Float64ToStrByPrec(v.Amount, 8), CommissionPrec, IsShowPoint)
		args.Uid = v.Uid
		args.MasterId = masterId
		args.PushType = "order_team"
		if v.Level == 0 && newOrd.OrderType == 0 {
			args.PushType = "order_self"
		}
		if v.Level == 0 && newOrd.OrderType == 1 {
			args.PushType = "order_share"
		}
		if v.Level == 0 || v.Amount > 0 {
			fmt.Println("----开始----")
			fmt.Println(args)
			push.CommAddPush(eg, args)
		}
	}

}
func AddVirCoin(eg *xorm.Engine, oid int64, vcrData []*model.VirtualCoinRelate, masterId string) {
	integralRelease, _ := db2.IntegralReleaseGetOneByParamsEg(eg, map[string]interface{}{
		"key":   "is_use",
		"value": 1,
	})
	if integralRelease != nil {
		//2、释放绿积分
		session := eg.NewSession()
		defer func() {
			session.Close()
			if err := recover(); err != nil {
				_ = zhios_order_relate_logx.Error(err)
			}
		}()
		session.Begin()
		rule.InitForIntegralRelease(cfg.RedisAddr)
		count, _ := session.Where("ord_id=?", oid).Count(&model.UserVirtualCoinFlow{})
		for _, v := range vcrData {
			if v.Level == 0 && utils.StrToFloat64(v.Amount) > 0 && v.CoinId == integralRelease.Coin1 {
				if count == 0 {
					err := rule.DealUserCoinForIntegralRelease(session, md2.DealUserCoinReq{
						Kind:         "add",
						Mid:          masterId,
						Title:        md2.IntegralReleaseRedCoinGrantByOrdTitleForUserVirtualCoinFlow,
						TransferType: md2.IntegralReleaseRedCoinGrantByOrdTransferTypeForUserVirtualCoinFlow,
						OrdId:        utils.Int64ToStr(v.Oid),
						CoinId:       v.CoinId,
						Uid:          v.Uid,
						Amount:       zhios_order_relate_utils.StrToFloat64(v.Amount),
					})
					if err != nil {
						session.Rollback()
						return
					}
				}
			}
		}
		session.Commit()
	}
	return
}

func CombineVirtualCoinRelateData(lvUser *comm_plan.LvUser, oid int64, pvd string, level int, mode string) []*model.VirtualCoinRelate {
	var data []*model.VirtualCoinRelate
	//可能没有极差返利  只有补贴
	profitList := lvUser.ProfitList
	if len(profitList) == 0 {
		profitList = lvUser.SubsidyFeeList
	}
	if profitList != nil {
		var subsidyFeeList map[string]float64
		if lvUser.SubsidyFeeList != nil && len(lvUser.ProfitList) > 0 {
			subsidyFeeList = convertList2Map(lvUser.SubsidyFeeList)
		}
		var coinList = make([]string, 0)
		for _, v := range profitList {
			coinList = append(coinList, v.Cid)
		}
		if utils.InArr(mode, []string{"lv_winery", "public_platoon"}) && lvUser.SubsidyFeeList != nil { //补贴类型 没有的要补上
			subsidyFeeList = convertList2Map(lvUser.SubsidyFeeList)
			for _, v := range lvUser.SubsidyFeeList {
				if utils.InArr(v.Cid, coinList) == false && v.Val > 0 {
					v.Val = 0
					profitList = append(profitList, v)
				}
			}
		}
		for _, item := range profitList {
			if item.Cid != "0" && item.Cid != "commission" {
				//加上补贴
				subsidyFee := subsidyFeeList[item.Cid]
				var ownSubsidyFee float64 = 0
				ownSubsidyFee1, ok := lvUser.OwnSubsidyFeeList[item.Cid]
				if ok {
					ownSubsidyFee = ownSubsidyFee1
				}
				var additionalSubsidy float64 = 0
				profit := utils.Float64ToStrByPrec(item.Val+subsidyFee+ownSubsidyFee, 9)
				if utils.InArr(mode, []string{"lv_winery", "public_platoon"}) {
					profit = utils.Float64ToStrByPrec(item.Val+ownSubsidyFee, 9)
					additionalSubsidy = subsidyFee

				}
				if mode == "public_platoon" && level > 1 {
					profit = "0"
				}
				if lvUser.Uid == 0 {
					continue
				}
				var virtualCoinRelate = &model.VirtualCoinRelate{
					Oid:               oid,
					Uid:               lvUser.Uid,
					CoinId:            utils.StrToInt(item.Cid),
					Amount:            profit,
					Pvd:               pvd,
					CreateAt:          int(time.Now().Unix()),
					Level:             level,
					Mode:              mode,
					AdditionalSubsidy: utils.Float64ToStrByPrec(additionalSubsidy, 6),
					ExtendType:        lvUser.ExtendType,
				}
				data = append(data, virtualCoinRelate)
			}
		}
	}
	if lvUser.ParentUser != nil {
		level += 1
		data = append(data, CombineVirtualCoinRelateData(lvUser.ParentUser, oid, pvd, level, mode)...)
	}
	return data
}
func CombineVirtualCoinRelateDataService(lvUser *comm_plan.LvUser, oid int64, pvd string, level int, mode string) []*model.VirtualCoinRelate {
	var data []*model.VirtualCoinRelate
	//可能没有极差返利  只有补贴
	profitList := lvUser.ProfitList
	if len(profitList) == 0 {
		profitList = lvUser.SubsidyFeeList
	}
	if profitList != nil {
		var subsidyFeeList map[string]float64
		if lvUser.SubsidyFeeList != nil && len(lvUser.ProfitList) > 0 {
			subsidyFeeList = convertList2Map(lvUser.SubsidyFeeList)
		}
		var coinList = make([]string, 0)
		for _, v := range profitList {
			coinList = append(coinList, v.Cid)
		}
		if utils.InArr(mode, []string{"lv_winery", "public_platoon"}) && lvUser.SubsidyFeeList != nil { //补贴类型 没有的要补上
			subsidyFeeList = convertList2Map(lvUser.SubsidyFeeList)
			for _, v := range lvUser.SubsidyFeeList {
				if utils.InArr(v.Cid, coinList) == false && v.Val > 0 {
					v.Val = 0
					profitList = append(profitList, v)
				}
			}
		}
		for _, item := range profitList {
			if item.Cid != "0" && item.Cid != "commission" {
				//加上补贴
				subsidyFee := subsidyFeeList[item.Cid]
				var ownSubsidyFee float64 = 0
				ownSubsidyFee1, ok := lvUser.OwnSubsidyFeeList[item.Cid]
				if ok {
					ownSubsidyFee = ownSubsidyFee1
				}
				var additionalSubsidy float64 = 0
				profit := utils.Float64ToStrByPrec(item.Val+subsidyFee+ownSubsidyFee, 9)
				if utils.InArr(mode, []string{"lv_winery", "public_platoon"}) {
					profit = utils.Float64ToStrByPrec(item.Val+ownSubsidyFee, 9)
					additionalSubsidy = subsidyFee

				}
				if mode == "public_platoon" && level > 1 {
					profit = "0"
				}
				if lvUser.Uid == 0 {
					continue
				}
				var virtualCoinRelate = &model.VirtualCoinRelate{
					Oid:               oid,
					Uid:               lvUser.Uid,
					CoinId:            utils.StrToInt(item.Cid),
					Amount:            profit,
					Pvd:               pvd,
					CreateAt:          int(time.Now().Unix()),
					Level:             level,
					Mode:              mode,
					AdditionalSubsidy: utils.Float64ToStrByPrec(additionalSubsidy, 6),
					ExtendType:        8,
				}
				data = append(data, virtualCoinRelate)
			}
		}
	}
	if lvUser.ParentUser != nil {
		level += 1
		data = append(data, CombineVirtualCoinRelateDataService(lvUser.ParentUser, oid, pvd, level, mode)...)
	}
	return data
}
func convertList2Map(a []*comm_plan.VirtualCoinCommission) (b map[string]float64) {
	b = make(map[string]float64)
	for _, i := range a {
		b[i.Cid] = i.Val
	}
	return b
}
