package svc

import (
	"applet/app/cfg"
	"applet/app/md"
	"applet/app/utils/cache"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"fmt"
	"github.com/tidwall/gjson"
	"strings"
	"time"

	"xorm.io/xorm"

	"applet/app/db"
	"applet/app/db/model"
	"applet/app/lib/plan"
	"applet/app/utils"
)

// 订单入库, TODO 1. 入库, 判断订单是否已经在库, 并到各个会员里面进行订单判断分润状态, 2.算利并进行分配, 所有订单都要进行拆单, 包括从智盟获取的订单
func OrderSaveUpdate(eg *xorm.Engine, pvd string, ordData *[]md.OrderInfo, opts map[string]*plan.PlanOpt, secondOpts map[string]*plan.PlanOpt, dbName string) error {
	var (
		allOrdIds        []string
		allStationOrdIds []int64
		stationOrdIds    []int64
		pids             []string
	)
	littlePocket := db.SysCfgFindWithDb(eg, dbName, "little_pocket_basic_data")
	returnMoneyType := "0"
	if littlePocket != nil && gjson.Get(littlePocket["little_pocket_basic_data"], "return_money_type").String() == "1" {
		returnMoneyType = "1"
	}
	var ch *rabbit.Channel
	var err error
	//if cfg.Prd {
	ch, err = rabbit.Cfg.Pool.GetChannel()
	if err == nil {
		defer ch.Release()
	}
	//}
	ords := map[string]md.OrderInfo{}
	for _, v := range *ordData {
		// 如果订单存在则更改订单状态, 其它不需要操作, 结算由另外一个任务进行结算
		ords[v.PvdOid] = v
		// 计算推广位
		if v.Pid != "" {
			pids = append(pids, v.Pid)
		}
		allOrdIds = append(allOrdIds, v.PvdOid)
	}
	fmt.Println(pids)
	if strings.Contains(pvd, "meituan") {
		pvd = "meituan"
	}
	if pvd == "hw_movie" {
		pvd = "cinema"
	}
	if pvd == md.PVD_PDDBYCREATETIME || pvd == md.PVD_PDDBYAGOTIME || pvd == md.PVD_PDDBYSTATUS || pvd == md.PVD_PDDBYSTATUSSUCCESS || pvd == md.PVD_PDDBYSTATUSFAIL { //判断下拼多多
		pvd = md.PVD_PDD
	}
	if pvd == md.PVD_JDUNIONOWN || pvd == md.PVD_JDUNIONOWNUPDATE || pvd == md.PVD_JDBYCREATETIME || pvd == md.PVD_JDBYSUCCESS || pvd == md.PVD_JDFAILBYCREATETIME || pvd == md.PVD_JDBYSTATUS { //判断下京东
		pvd = md.PVD_JD
	}
	if utils.InArr(pvd, []string{"csjp_create", "own_csjp", "own_csjp_activity"}) {
		pvd = "csjp"
	}
	if utils.InArr(pvd, []string{"own_csjp_live"}) {
		pvd = "csjp_live"
	}
	if utils.InArr(pvd, []string{md.PVD_TB12, md.PVD_TB13, md.PVD_TB14, md.PVD_TB3, md.PVD_TBBYPAY, md.PVD_TBBYCREATETIME, md.PVD_TBBYSETTLE}) {
		pvd = md.PVD_TB
	}
	if pvd == md.PVD_DIDI_ENERGY { //
		pvd = "oil"
	}
	if pvd == md.PVD_TO_KFC { //判断下
		pvd = md.PVD_KFC
	}
	if pvd == md.PVD_TIKTOKOWNLIVE { //判断下
		pvd = md.PVD_TIKTOKLIVE
	}
	if utils.InArr(pvd, []string{md.PVD_TIKTOKOwn, md.PVD_TIKTOKOwnCreate, md.PVD_TIKTOKOwnActivity, md.PVD_TIKTOKOwnMix}) { //判断下
		pvd = md.PVD_TIKTOK
	}
	if utils.InArr(pvd, []string{md.PVD_KuaishouOwn, md.PVD_KuaishouOwnCreate}) { //判断下
		pvd = md.PVD_KUAISHOU
	}

	// 用推广位计算出查询对应人员的等级
	userInfo := parsePids(eg, dbName, pvd, pids)

	pidToUser := map[string]*md.UserPid{}
	for _, vv := range userInfo {
		if pvd == md.PVD_TB {
			prefix := "self_"
			if vv.OrderType == md.OrderTypeShare {
				prefix = "share_"
			}
			if vv.OrderType == md.OrderTypeFree {
				prefix = "free_"
			}
			if vv.OrderType == 15 {
				prefix = "relationfree_"
			}
			if vv.OrderType == md.OrderTypeTljFree {
				prefix = "tljfree_"
			}
			if vv.OrderType == 16 {
				prefix = "ttljfree_"
			}
			if vv.OrderType == 10 {
				prefix = "cloud_"
			}
			if vv.OrderType == md.OrderTypeTljRelationFree {
				prefix = "tljrelationfree_"
			}
			if vv.OrderType == md.OrderTypeActSelf {
				prefix = "actself_"
			}
			if vv.OrderType == md.OrderTypeWechatActShare {
				prefix = "wechatactshare_"
			}
			if vv.OrderType == md.OrderTypeWechatActSelf {
				prefix = "wechatactself_"
			}
			if vv.OrderType == md.OrderTypeWechatActSelfNew {
				prefix = "wechatactselfnew_"
			}
			pidToUser[prefix+vv.Pid] = vv
		} else {
			if len(vv.Pids) > 0 {
				for _, v1 := range vv.Pids {
					pidToUser[v1] = vv
				}
			} else {
				pidToUser[vv.Pid] = vv
			}
		}
	}
	now := int(time.Now().Unix())
	existOrds, _ := db.DbsOrderFindByIds(eg, pvd, allOrdIds)
	fmt.Println(existOrds)

	// 更新订单
	if existOrds != nil {
		var commissionReqList = make([]md.CommissionFirstParam, 0)
		var tikTokOrdMap = make(map[string]model.OrdList, 0)
		var returnMoneyReqList = make([]map[string]string, 0)

		for _, v := range *existOrds {
			v.BenefitAll = utils.FloatFormat(v.BenefitAll, 3)
			allStationOrdIds = append(allStationOrdIds, v.OrdId)
			if v.ConfirmAt == 0 {
				if int(ords[v.PvdOid].ConfirmAt) > 0 {
					v.ConfirmAt = int(ords[v.PvdOid].ConfirmAt)
					_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
				} else if v.PvdSettleAt > 0 {
					v.ConfirmAt = v.PvdSettleAt
					_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
				}
			}

			if int(ords[v.PvdOid].ConfirmAt) > 0 && v.ConfirmAt != int(ords[v.PvdOid].ConfirmAt) {
				v.ConfirmAt = int(ords[v.PvdOid].ConfirmAt)
				_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
			}
			if v.OrderCompare == 0 && ords[v.PvdOid].IsCompare == 1 {
				v.OrderCompare = ords[v.PvdOid].IsCompare
				_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
			}
			if v.CheckSuccessAt == 0 && int(ords[v.PvdOid].CheckSuccessAt) > 0 {
				v.CheckSuccessAt = int(ords[v.PvdOid].CheckSuccessAt)
				_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
			}
			//更新下父级订单号
			if v.ParentOrdId == 0 && v.Pvd == md.PVD_TB && ords[v.PvdOid].ParentOrdId != 0 {
				v.ParentOrdId = ords[v.PvdOid].ParentOrdId
				_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
			}
			//拼多多的有些读错价格了
			if v.PaidPrice != ords[v.PvdOid].PaidPrice && v.Pvd == md.PVD_PDD {
				v.PaidPrice = ords[v.PvdOid].PaidPrice
				fmt.Println("拼多多改价格")
				_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
			}
			//判断是否失效订单并且平台结算过  扣除佣金
			if v.PriceType > 0 || v.ThirdPriceType > 0 {
				//直接退回账号了 定制
				storeOrder := db.GuideStoreOrder(eg, v.OrdId)
				if storeOrder != nil {
					isSet := 0
					if v.State != ords[v.PvdOid].State {
						storeOrder.State = ords[v.PvdOid].State
						isSet = 1
					}
					if v.SettleAt > 0 {
						isSet = 1
						storeOrder.SettleAt = v.SettleAt
					}
					if isSet == 1 {
						eg.Where("id=?", storeOrder.Id).Update(storeOrder)
					}
				}
			}

			if ords[v.PvdOid].State == 4 {
				// 加锁 防止并发退款
				mutexKey := fmt.Sprintf("%s:all_order_refund:%d:pvd:%s", dbName, v.OrdId, v.Pvd)
				available, err := cache.Do("SET", mutexKey, 1, "EX", 5, "NX")
				if err != nil {
					continue
				}
				if available != "OK" {
					continue
				}
				if v.SettleAt > 0 || v.State == 5 {
					RefundDoing(eg, returnMoneyType, &v, "", dbName)
					continue
				} else {
					NotSettleDeduct(eg, &v, dbName)
				}
				if v.State != 4 && v.PriceType > 0 {
					m, _ := db.FreeProductByID(eg, v.ItemId, v.NumItemId, v.Pvd)
					//直接退回账号了 定制
					storeOrder := db.GuideStoreOrder(eg, v.OrdId)
					if m != nil {
						if storeOrder == nil {
							m.Stock++
							m.Sale--
							if m.Sale < 0 {
								m.Sale = 0
							}
							eg.Where("id=?", m.Id).Cols("sale,stock").Update(m)
						} else if storeOrder != nil && utils.StrToFloat64(storeOrder.DeductPrice) > 0 && storeOrder.DeductState == 1 {
							arg := md.ZhiosGuideStoreOrder{
								Uid:    utils.IntToStr(v.Uid),
								Mid:    dbName,
								Oid:    utils.Int64ToStr(v.OrdId),
								Pvd:    v.Pvd,
								ItemId: v.ItemId,
								Type:   "fail",
							}
							if cfg.Prd {
								ch.Publish(md.GuideStoreOrder, utils.SerializeStr(arg), md.GuideStoreRoutKeyForOrder)
							} else {
								ch.Publish(md.GuideStoreOrder, utils.SerializeStr(arg), md.GuideStoreRoutKeyForOrderDev)
							}
						}
					}
				}
				if v.State != 4 && v.SecondPriceType > 0 {
					m, _ := db.SecondFreeProductByID(eg, v.ItemId, v.NumItemId, v.Pvd)
					if m != nil {
						m.Stock++
						m.Sale--
						if m.Sale < 0 {
							m.Sale = 0
						}
						eg.Where("id=?", m.Id).Cols("sale,stock").Update(m)
					}
				}
				if v.State == 4 && v.PriceType > 0 {
					m, _ := db.FreeProductByID(eg, v.ItemId, v.NumItemId, v.Pvd)
					//直接退回账号了 定制
					storeOrder := db.GuideStoreOrder(eg, v.OrdId)
					if m != nil {
						if storeOrder != nil && utils.StrToFloat64(storeOrder.DeductPrice) > 0 && storeOrder.DeductState == 1 {
							arg := md.ZhiosGuideStoreOrder{
								Uid:    utils.IntToStr(v.Uid),
								Mid:    dbName,
								Oid:    utils.Int64ToStr(v.OrdId),
								Pvd:    v.Pvd,
								ItemId: v.ItemId,
								Type:   "fail",
							}
							if cfg.Prd {
								ch.Publish(md.GuideStoreOrder, utils.SerializeStr(arg), md.GuideStoreRoutKeyForOrder)
							} else {
								ch.Publish(md.GuideStoreOrder, utils.SerializeStr(arg), md.GuideStoreRoutKeyForOrderDev)
							}
						}
					}

				}
				if v.State == 4 && v.ThirdPriceType > 0 {
					m, _ := db.MoreFreeProductByID(eg, v.ItemId, v.NumItemId, v.Pvd)
					//直接退回账号了 定制
					storeOrder := db.GuideStoreOrder(eg, v.OrdId)
					if m != nil {
						if storeOrder != nil && utils.StrToFloat64(storeOrder.DeductPrice) > 0 && storeOrder.DeductState == 1 {
							arg := md.ZhiosGuideStoreOrder{
								Uid:    utils.IntToStr(v.Uid),
								Mid:    dbName,
								Oid:    utils.Int64ToStr(v.OrdId),
								Pvd:    v.Pvd,
								ItemId: v.ItemId,
								Type:   "fail",
							}
							if cfg.Prd {
								ch.Publish(md.GuideStoreOrder, utils.SerializeStr(arg), md.GuideStoreRoutKeyForOrder)
							} else {
								ch.Publish(md.GuideStoreOrder, utils.SerializeStr(arg), md.GuideStoreRoutKeyForOrderDev)
							}
						}
					}
				}

			}
			if ords[v.PvdOid].State == 3 && utils.InArr(utils.IntToStr(v.State), []string{"3", "4", "5"}) == false && v.PvdSettleAt > 0 {
				v.State = 3
				if v.IsTikTokTeamOrder == 1 {
					isRe := 0
					TikTokTeamCommission := utils.StrToFloat64(v.TikTokTeamRealCommission)
					if TikTokTeamCommission != utils.StrToFloat64(ords[v.PvdOid].TikTokTeamRealCommission) && TikTokTeamCommission > 0 {
						isRe = 1
						v.TikTokTeamRealCommission = ords[v.PvdOid].TikTokTeamRealCommission
					}
					if utils.StrToFloat64(ords[v.PvdOid].TikTokTeamCommission) != utils.StrToFloat64(v.TikTokTeamCommission) {
						if TikTokTeamCommission == 0 {
							isRe = 1
							TikTokTeamCommission = utils.StrToFloat64(ords[v.PvdOid].TikTokTeamCommission)
						}
						v.TikTokTeamCommission = ords[v.PvdOid].TikTokTeamCommission
					}
					if isRe == 1 {
						isShare := 0
						if v.OrderType == md.OrderTypeShare || v.OrderType == md.OrderTypeWechatActShare {
							isShare = 1
						}
						req := md.CommissionFirstParam{
							CommissionParam: md.CommissionParam{
								Commission:           utils.Float64ToStr(v.BenefitAll),
								PaidPrice:            utils.Float64ToStr(v.PaidPrice),
								OldPrice:             utils.Float64ToStr(v.PaidPrice),
								TikTokTeamCommission: utils.Float64ToStr(TikTokTeamCommission),
								IsTikTokTeamOrder:    utils.IntToStr(v.IsTikTokTeamOrder),
							},
							Uid:              utils.IntToStr(v.Uid),
							IsShare:          isShare,
							Provider:         v.Pvd,
							IsAllLevelReturn: 0,
							Oid:              v.PvdOid,
						}
						tikTokOrdMap[v.PvdOid] = v
						commissionReqList = append(commissionReqList, req)
					}
				}
				_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
			}
			if v.State != ords[v.PvdOid].State && (v.State != 4 || v.Pvd == md.PVD_JD || v.Pvd == md.PVD_JDOwn || v.Pvd == md.PVD_ELM) {
				if ords[v.PvdOid].Reason != "" {
					v.Reason = ords[v.PvdOid].Reason
				}
				v.State = ords[v.PvdOid].State
				if ords[v.PvdOid].State != 4 && (v.State == 5 || v.SettleAt > 0) { //如果不是失效 平台结算状态都不改了
					v.State = 5
				}
				v.UpdateAt = now
				if utils.InArr(utils.IntToStr(v.State), []string{"1", "2"}) && v.ConfirmAt == 0 {
					if ords[v.PvdOid].ConfirmAt > 0 {
						v.ConfirmAt = int(ords[v.PvdOid].ConfirmAt)
					} else {
						v.ConfirmAt = v.UpdateAt
					}
				}
				// 供应商结算时间
				if v.State == md.OrderStatePvdSettle {
					if ords[v.PvdOid].EndTime > 0 {
						v.PvdSettleAt = int(ords[v.PvdOid].EndTime)
					} else {
						v.PvdSettleAt = v.UpdateAt
					}
				}
				_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
				//查询优惠券使用记录
				if v.State == 4 {
					//commCheckCoupon(eg, v.Uid, v.ItemId, 1, 0, v.Pvd)
					commRefundCoupon(eg, v.Uid, v.ItemId, 1, 0, v.Pvd)
				}
				//如果是光汇加油的 要改下另一个表
				if ords[v.PvdOid].Source == "5" {
					state := 1
					if v.State == 4 {
						state = 2
					}
					db.BrightOilUpdate(eg, ords[v.PvdOid].PvdOid, state)
				}
				// newOrder hook
			}
			if v.State != 4 && ords[v.PvdOid].State != 4 {
				AcquisitionHookFirstOrder(eg, dbName, &v)
				if v.WaitSettleAt == 0 && v.State != 4 {
					v.WaitSettleAt = int(ords[v.PvdOid].WaitSettleAt)
					_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
				}
			}
			if v.State == 4 && (v.Pvd == md.PVD_JD || v.Pvd == md.PVD_JDOwn) && ords[v.PvdOid].State != 4 {
				v.State = ords[v.PvdOid].State
				_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
			}
			//如果没有用户这里要做处理 仅针对淘宝 或美团联盟没有佣金的情况
			commCheckUser(eg, v, ords, pvd, pidToUser, opts, secondOpts, dbName, false, returnMoneyType)

		}
		//处理下没有分佣明细的订单
		existRelateOrds, _ := db.DbsOrderRelateFindByIds(eg, pvd, allStationOrdIds)
		if existRelateOrds != nil {
			for _, v := range *existRelateOrds {
				stationOrdIds = append(stationOrdIds, v.Oid)
			}
		}
		for _, v := range *existOrds {
			v.BenefitAll = utils.FloatFormat(v.BenefitAll, 3)
			result := in(v.OrdId, stationOrdIds)
			if result == false {
				//如果没有用户这里要做处理 仅针对淘宝 或美团联盟没有佣金的情况
				commCheckUser(eg, v, ords, pvd, pidToUser, opts, secondOpts, dbName, true, returnMoneyType)
			}
			// 去除已存在订单
			delete(ords, v.PvdOid)
		}
		if len(commissionReqList) > 0 { //处理抖音团长结算的订单
			commissionListArr, _ := GetMoreRebateResult(eg, dbName, returnMoneyType, commissionReqList, returnMoneyReqList)
			for k, v := range commissionListArr {
				ord, ok := tikTokOrdMap[k]
				if ok && v.LvUser != nil && v.LvUser.TikTokOwnSubsidyFeeList != nil {
					db.TikTokTeamOrderRelateDeleteByOid(eg, ord.OrdId, pvd)
					var teamData []model.TikTokTeamOrderRelate
					TikTokTeamCommission := ord.TikTokTeamCommission
					if utils.StrToFloat64(ord.TikTokTeamRealCommission) > 0 {
						TikTokTeamCommission = ord.TikTokTeamRealCommission
					}
					for k1, v1 := range v.LvUser.TikTokOwnSubsidyFeeList {
						tmp := model.TikTokTeamOrderRelate{
							CoinId:     utils.StrToInt(k1),
							Uid:        ord.Uid,
							Amount:     utils.Float64ToStrByPrec(v1, 8),
							Oid:        utils.Int64ToStr(ord.OrdId),
							Time:       time.Now(),
							Commission: TikTokTeamCommission,
							Pvd:        pvd,
						}
						teamData = append(teamData, tmp)
					}
					db.DbInsertBatch(eg, &teamData)
				}
			}
		}
	}

	//判断饿了么的
	if pvd == md.PVD_TB {
		eleExistOrds, _ := db.DbsOrderFindByIds(eg, "ele", allOrdIds)
		// 更新订单
		if eleExistOrds != nil {
			for _, v := range *eleExistOrds {
				if v.State != ords[v.PvdOid].State {
					v.Reason = ords[v.PvdOid].Reason
					v.State = ords[v.PvdOid].State
					v.UpdateAt = now
					if v.State == md.OrderStateSucc {
						v.ConfirmAt = v.UpdateAt
					}
					// 供应商结算时间
					if v.State == md.OrderStatePvdSettle {
						v.PvdSettleAt = v.UpdateAt
						if ords[v.PvdOid].EndTime > 0 {
							v.PvdSettleAt = int(ords[v.PvdOid].EndTime)
						}
					}
					_ = db.DbsOrderUpdate(eg, v.OrdId, &v)
				}
				//如果没有用户这里要做处理 仅针对淘宝
				commCheckUser(eg, v, ords, pvd, pidToUser, opts, secondOpts, dbName, false, returnMoneyType)
				// 去除已存在订单
				delete(ords, v.PvdOid)
			}
		}
	}
	return nil
}
