package svc

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/app/md"
	"applet/app/utils"
	md2 "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule"
	"crypto/tls"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
	"strings"
	"time"
	"xorm.io/xorm"
)

// SaveOrderByCommApi 调用公共接口保存区域订单
func SaveOrderByCommApi(eg *xorm.Engine, masterId string, req *md.InsertRegionalAgentOrdBelongData) {
	subCommission := utils.Float64ToStrByPrec(utils.FloatFormat(utils.StrToFloat64(req.Commission)*req.RegionSubRate, 8), 8) //算出区域代理能分的钱
	req.Commission = utils.Float64ToStrByPrec(utils.FloatFormat(utils.StrToFloat64(req.Commission)*req.RegionRate, 8), 8)    //算出区域代理能分的钱
	var tmp = &md2.InsertRegionalAgentOrdBelongData{
		Uid:        req.Uid,
		Pvd:        req.Pvd,
		CommPvd:    req.CommPvd,
		Commission: req.Commission,
		OrderId:    req.OrderId,
		Status:     req.Status,
	}
	rule.BindUserOrdToAgent(eg, masterId, tmp)
	tmp.Commission = subCommission
	rule.BindUserOrdToSubAgent(eg, masterId, tmp)
	return
}

func SaveOrderByChangeState(eg *xorm.Engine, masterId string, ids []string, pvd string) {
	if ids == nil {
		return
	}
	m := db.SysCfgGetWithDb(eg, masterId, "regional_agent_is_open")
	if m == "" {
		return
	}
	if m != "1" {
		return
	}
	host := cfg.AppComm.URL + "/api/v1/comm/RegionalAgent/updateRegionalAgentCalcSystemRelate"
	tr := &http.Transport{
		TLSClientConfig: &tls.Config{InsecureSkipVerify: true},
	}
	client := &http.Client{
		Timeout:   15 * time.Second,
		Transport: tr,
	}
	byte1, _ := json.Marshal(map[string]interface{}{"ids": ids, "pvd": pvd})
	fmt.Println(string(byte1))
	req1, _ := http.NewRequest("POST", host, strings.NewReader(string(byte1)))
	req1.Header.Set("master_id", masterId)
	req1.Header.Set("Content-Type", "application/json")
	resp, err := (client).Do(req1)
	if err != nil || resp == nil {
		return
	}
	defer resp.Body.Close()
	respByte, _ := ioutil.ReadAll(resp.Body)

	if len(respByte) == 0 {
		return
	}
	var serverResp map[string]interface{}
	err = json.Unmarshal(respByte, &serverResp)
	if err != nil || serverResp == nil {
		return
	}
	if serverResp["data"] == nil {
		if serverResp["msg"] != "" {
			return
		}
		return
	}
	return
}
