package md

type MqQueue struct {
	ExchangeName   string `json:"exchangeName"`     //交换机名字
	Name           string `json:"name"`             //队列名字
	Type           string `json:"type"`             //队列类型
	IsPersistent   bool   `json:"is_persistent"`    //队列是否持久化
	RoutKey        string `json:"rout_key"`         //路由
	BindKey        string `json:"bind_key"`         //绑定的路由
	ConsumeFunName string `json:"consume_fun_name"` //消费方法
}

var RabbitMqQueueKeyList = []*MqQueue{
	{
		ExchangeName:   "zhios.order_track_update.exchange",
		Name:           "order_track_update_for_tb",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "tb",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTrackUpdateForTbConsume",
	},
	{
		ExchangeName:   "zhios.order_track_update.exchange",
		Name:           "order_track_update_for_jd",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "jd",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTrackUpdateForJdConsume",
	},
	{
		ExchangeName:   "zhios.order_track_create.exchange",
		Name:           "order_track_create_for_tb",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "tb",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTrackCreateForTbConsume",
	},
	{
		ExchangeName:   "zhios.order_track_create.exchange",
		Name:           "order_track_create_for_jd",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "jd",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTrackCreateForJdConsume",
	},
	{
		ExchangeName:   "zhios.order_track_create.exchange",
		Name:           "order_track_create_for_pdd",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "pdd",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTrackCreateForPddConsume",
	},
	{
		ExchangeName:   "zhios.order_track_create.exchange",
		Name:           "order_track_create_for_wph",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "vip",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTrackCreateForWphConsume",
	},
	{
		ExchangeName:   "zhios.order_track_create.exchange",
		Name:           "order_track_create_for_tik_tok_team",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "tik_tok_team",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTrackCreateForTikTokTeamConsume",
	},
	{
		ExchangeName:   "zhios.order_track_refund.exchange",
		Name:           "order_track_refund_for_tb_all",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "tb_for_all",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTrackRefundForTbAllConsume",
	},
	{
		ExchangeName:   "zhios.order_track_refund.exchange",
		Name:           "order_track_refund_for_tb_part",
		Type:           DirectQueueType,
		IsPersistent:   false,
		RoutKey:        "tb_for_part",
		BindKey:        "",
		ConsumeFunName: "ZhiosOrderTrackRefundForTbPartConsume",
	},
}

const (
	ZhiosOrderTrackUpdateForTbConsumeFunName         = "ZhiosOrderTrackUpdateForTbConsume"
	ZhiosOrderTrackCreateForTbConsumeFunName         = "ZhiosOrderTrackCreateForTbConsume"
	ZhiosOrderTrackCreateForJdConsumeFunName         = "ZhiosOrderTrackCreateForJdConsume"
	ZhiosOrderTrackCreateForPddConsumeFunName        = "ZhiosOrderTrackCreateForPddConsume"
	ZhiosOrderTrackCreateForWphConsumeFunName        = "ZhiosOrderTrackCreateForWphConsume"
	ZhiosOrderTrackCreateForTikTokTeamConsumeFunName = "ZhiosOrderTrackCreateForTikTokTeamConsume"
	ZhiosOrderTrackUpdateForJdConsumeFunName         = "ZhiosOrderTrackUpdateForJdConsume"
	ZhiosOrderTrackRefundForTbAllConsumeFunName      = "ZhiosOrderTrackRefundForTbAllConsume"
	ZhiosOrderTrackRefundForTbPartConsumeFunName     = "ZhiosOrderTrackRefundForTbPartConsume"
)
